/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ2760678933$}}
 */

/*
 * Changes are Copyright (c) 2005 Your Company. All Rights Reserved. 
 * 
 * Generated by an evaluation version of RapidJ for EVALUATION PURPOSES ONLY.
 * 
 * This copyright header can be customised in the licensed version of RapidJ.
 */
package com.company.customer.web.action;

import java.util.ArrayList;
import java.util.Iterator;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForward;

import com.company.customer.data.dao.DAOs;
import com.company.customer.data.dso.*;
import com.company.customer.data.to.*;
import com.company.customer.util.dao.PagedData;
import com.company.customer.util.ApplicationProperties;
import com.company.customer.util.action.ActionException;
import com.company.customer.util.database.DatabaseUtils;
import com.company.customer.util.identity.IdentityUtils;
import com.company.customer.web.form.CustomersForm;
import com.company.customer.web.fo.*;

/**
 * This Action class manages Customerss.
 */
public class CustomersAction extends ActionBase {

	/**
	 * Log4J Logger for this class
	 */
	public static final Logger logger = Logger.getLogger(CustomersAction.class);

	/**
	 * Delegates to the top level method for this action.
	 *
	 * @param request - the current Request.
	 * @param form - the form.
	 */
	public void executeDefault(Request request, CustomersForm form) throws Exception {
		executeCustomersList(request, form);
	}

	// ---- Start Customers Component Methods ----

	// Include from '/generic/includes/Action_______LP.java.ftl'

	/**
	 * Lists all Customers
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	public void executeCustomersList(Request request, CustomersForm form) throws Exception {

		// Load the list of all Customers
		PagedData customerTOs = DAOs.getCustomerDAO().
			getAllCustomers(
				form.getCustomerName(),
				form.getCustomersPageNumber(),
				ApplicationProperties.getInstance().getIntegerProperty(
					ApplicationProperties.CUSTOMERS_PAGESIZE, 10).intValue());
		form.setCustomersCustomerTOs(customerTOs);

		// Update the page number
		form.setCustomersPageNumber(customerTOs.getPageNumber());

	}

	/**
	 * Delete the specified Customers
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	public void executeCustomersDelete(Request request, CustomersForm form) throws Exception {

		// Check that the id has been specified
		Long id = form.getCustomersCustomerId();
		if (id==null) {
			throw new ActionException(
					ActionException.MISSING_REQUIRED_PARAMETER,
					"customersCustomerId", null);
		}

		try {

			// Begin the transaction
			DatabaseUtils.begin();

			// Delete the specified Customers
			DAOs.getCustomerDAO().deleteCustomer(id);

			// Commit the transaction
			DatabaseUtils.commit();

		} catch (Exception e) {
			// Rollback the transaction and throw exception on.
			DatabaseUtils.rollback();
			throw e;
		}

		// Add a delete successfull message
		addGlobalMessage(request, "common.deleteOk");

		// Execute the top level method
		executeDefault(request, form);

	}

	/**
	 * Clears the Customers form variables and children components.
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	private void saveCustomers(Request request, CustomersForm form) throws Exception {

	}

	/**
	 * Clears all of the Customers form variables.
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	private void clearCustomers(Request request, CustomersForm form) throws Exception {

		// Clear the Customers form variables
		form.setCustomersCustomerTOs(null);
		form.setCustomersCustomerId(null);

	}

	// ---- End Customers Component Methods ----


}
