<#-- START TEMPLATE HEADER -->
<#-- category=appservers/weblogic/7.0 -->
<#-- type=application -->
<#-- version=1.0 -->
<#-- fileNameTemplate=struts-config.xml -->
<#-- relativeOutputDirectory=web/WEB-INF -->
<#-- END TEMPLATE HEADER -->
<?xml version="1.0" encoding="ISO-8859-1" ?>

<!DOCTYPE struts-config PUBLIC
          "-//Apache Software Foundation//DTD Struts Configuration 1.1//EN"
          "http://jakarta.apache.org/struts/dtds/struts-config_1_1.dtd">

<!--

  Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.

  Modification and redistribution of this file is permitted subject to the
  terms and conditions of the RapidJ End User License Agreement:
  http://www.codecanvas.com.au/rapidj/license.php

  {{$RapidJ$}}

-->

<!--

${f.formatLines(project.copyright, '  ', 80)}

-->

<!--

  Weblogic 7 does not allow access to WEB-INF even from the server side. This
  means that JSPs accessed via Struts can not be placed in WEB-INF as usual.

-->

<struts-config>


  <!-- ========== Data Source Configuration =============================== -->
  <!-- ========== Form Bean Definitions =================================== -->
  <form-beans>

	<!-- GENERATED -->
<#list guiComponents as guiComponent>
	<#if !guiComponent.internalParent?exists>
    <form-bean      name="${f.att(guiComponent.name)}Form"
                    type="${project.rootPackage}.web.form.${f.cla(guiComponent.name)}Form"/>
	</#if>
</#list>
  </form-beans>

  <!-- ========== Global Exception Definitions ============================ -->
  <global-exceptions>
    <exception   handler="${project.rootPackage}.util.action.ExceptionHandler"
                     key="global.error.message"
                    path="/jsp/actionError.jsp"
                   scope="request"
                    type="java.lang.Exception"/>
  </global-exceptions>


  <!-- ========== Global Forward Definitions ============================== -->
  <global-forwards>
    <forward   name="home"             path="/index.jsp"/>
  </global-forwards>


  <!-- ========== Action Mapping Definitions ============================== -->
  <action-mappings>
<#list guiComponents as guiComponent>
	<#if !guiComponent.internalParent?exists>

	<!-- ${f.cla(guiComponent.name)} -->
    <action    path="/${f.att(guiComponent.name)}"
               type="${project.rootPackage}.web.action.${f.cla(guiComponent.name)}Action"
               name="${f.att(guiComponent.name)}Form"
              scope="session"
           validate="false">
      <forward name="success"              path="/jsp/${f.att(guiComponent.name)}.jsp"/>
      <forward name="validate"             path="/${f.att(guiComponent.name)}Validate.do"/>
    </action>
    <action    path="/${f.att(guiComponent.name)}Validate"
               type="${project.rootPackage}.web.action.${f.cla(guiComponent.name)}Action"
               name="${f.att(guiComponent.name)}Form"
              scope="session"
              input="success"
           validate="true">
      <forward name="success"              path="/jsp/${f.att(guiComponent.name)}.jsp"/>
    </action>
	</#if>
</#list>
  </action-mappings>

  <!-- ========== Controller Configuration ================================ -->

  <controller>
    <!-- The "input" parameter on "action" elements is the name of a
         local or global "forward" rather than a module-relative path -->
    <set-property property="inputForward" value="true"/>
  </controller>


  <!-- ========== Message Resources Definitions =========================== -->

  <message-resources
    parameter="${project.rootPackage}.ApplicationResources"/>

  <!-- ========== Plug Ins Configuration ================================== -->

  <!--
     Add multiple validator resource files by setting the pathnames property
     with a comma delimitted list of resource files to load.
  -->
  <plug-in className="org.apache.struts.validator.ValidatorPlugIn">
    <set-property property="pathnames" value="/WEB-INF/validator-rules.xml,
                                              /WEB-INF/validation.xml"/>
  </plug-in>

</struts-config>
