<#-- START TEMPLATE HEADER -->
<#-- category=databases/mysql/4.0 -->
<#-- type=entity -->
<#-- version=1.0 -->
<#-- fileNameTemplate=${f.col(entity.name)}-sql.xml -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=data.dao -->
<#-- END TEMPLATE HEADER -->
<?xml version="1.0" encoding="ISO-8859-1" ?>

<!--

  Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.

  Modification and redistribution of this file is permitted subject to the
  terms and conditions of the RapidJ End User License Agreement:
  http://www.codecanvas.com.au/rapidj/license.php

  {{$RapidJ$}}

-->

<!--

${f.formatLines(project.copyright, '  ', 80)}

-->

<sql-queries>
	<sql key="getAll${f.cla(entity.name)}s">
		<![CDATA[
		SELECT
			*
		FROM
			${f.tab(entity.name)}
		]]>
	</sql>
	<sql key="get${f.cla(entity.name)}">
		<![CDATA[
		SELECT
			*
		FROM
			${f.tab(entity.name)}
		WHERE
			${f.col(entity.name)}_id = :${f.att(entity.name)}Id
		]]>
	</sql>
	<sql key="count${f.cla(entity.name)}">
		<![CDATA[
		SELECT
			count(*)
		FROM
			${f.tab(entity.name)}
		WHERE
			${f.col(entity.name)}_id = :${f.att(entity.name)}Id
		]]>
	</sql>
<#list entity.identifyingRelationshipsWithParents as relationship>
	<sql key="count${f.cla(entity.name)}sFor${f.cla(relationship.parentAssociationName)}">
		<![CDATA[
		SELECT
			count(*)
		FROM
			${f.tab(entity.name)}
		WHERE
			${f.col(relationship.parentAssociationName)}_id = :${f.att(relationship.parentAssociationName)}Id
		${"<#if " + f.att(entity.name) + "Id?exists>"}
		AND
			${f.col(entity.name)}_id = :${f.att(entity.name)}Id
		${"</#if>"}
		]]>
	</sql>
	<#if relationship.isOneToMany()>
	<sql key="get${f.cla(entity.name)}sFor${f.cla(relationship.parentAssociationName)}">
		<![CDATA[
		SELECT
			*
		FROM
			${f.tab(entity.name)}
		WHERE
			${f.col(relationship.parentAssociationName)}_id = :${f.att(relationship.parentAssociationName)}Id
		]]>
	</sql>
	<#else>
	<sql key="get${f.cla(entity.name)}For${f.cla(relationship.parentAssociationName)}">
		<![CDATA[
		SELECT
			*
		FROM
			${f.tab(entity.name)}
		WHERE
			${f.col(relationship.parentAssociationName)}_id = :${f.att(relationship.parentAssociationName)}Id
		]]>
	</sql>
	</#if>
</#list>
<#-- MySQL does not support sub queries untill version 4.1 -->
<#-- You can often rewrite the query without a subquery -->
<#list entity.identifyingRelationshipsWithChildren as relationship>
	<#if relationship.isOneToOne()>
	<sql key="get${f.cla(entity.name)}sWithNo${f.cla(relationship.childAssociationName)}">
		<![CDATA[
		SELECT
			${f.tab(entity.name)}.*
		FROM
			${f.tab(entity.name)} LEFT JOIN ${f.tab(relationship.child.name)}
				ON ${f.tab(entity.name)}.${f.col(entity.name)}_id = ${f.tab(relationship.child.name)}.${f.col(relationship.parentAssociationName)}_id
					WHERE (${f.tab(entity.name)}.${f.col(entity.name)}_id = :${f.att(entity.name)}Id) OR
						  (${f.tab(relationship.child.name)}.${f.col(relationship.parentAssociationName)}_id IS NULL);
		]]>
	</sql>
	</#if>
</#list>
	<sql key="delete${f.cla(entity.name)}">
		<![CDATA[
		DELETE FROM
			${f.tab(entity.name)}
		WHERE
			${f.col(entity.name)}_id = :${f.att(entity.name)}Id
		]]>
	</sql>
<#list entity.identifyingRelationshipsWithParents as relationship>
	<#if relationship.isOneToMany()>
	<sql key="delete${f.cla(entity.name)}sFor${f.cla(relationship.parentAssociationName)}">
		<![CDATA[
		DELETE FROM
			${f.tab(entity.name)}
		WHERE
			${f.col(relationship.parentAssociationName)}_id = :${f.att(relationship.parentAssociationName)}Id
		]]>
	</sql>
	<#else>
	<sql key="delete${f.cla(entity.name)}For${f.cla(relationship.parentAssociationName)}">
		<![CDATA[
		DELETE FROM
			${f.tab(entity.name)}
		WHERE
			${f.col(relationship.parentAssociationName)}_id = :${f.att(relationship.parentAssociationName)}Id
		]]>
	</sql>
	</#if>
</#list>
<#list entity.relationships as relationship>
	<#if relationship.parent == entity && !relationship.identifying>
	<sql key="clearReferencesTo${f.cla(relationship.childAssociationName)}">
		<![CDATA[
		UPDATE
			${f.tab(entity.name)}
		SET
			${f.col(relationship.childAssociationName)}_id = null
		WHERE
			${f.col(relationship.childAssociationName)}_id = :${f.att(relationship.childAssociationName)}Id;
		]]>
	</sql>
	</#if>
</#list>
	<sql key="insert${f.cla(entity.name)}">
		<![CDATA[
		INSERT INTO ${f.tab(entity.name)} (
			${f.col(entity.name)}_id,
<#list entity.relationships as relationship>
	<#if relationship.child == entity>
		<#-- Parent relationship -->
		<#if relationship.identifying>
			${f.col(relationship.parentAssociationName)}_id,
 		</#if>
 	<#else>
 		<#-- Child relationship -->
 		<#if !relationship.identifying>
			${f.col(relationship.childAssociationName)}_id,
	 	</#if>
	 </#if>
</#list>
<#list entity.attributes as attribute>
			${f.col(attribute.name)},
</#list>
			version,
			update_datetime,
			update_uid,
			create_datetime,
			create_uid)
		VALUES (
			:${f.att(entity.name)}Id,
<#list entity.relationships as relationship>
	<#if relationship.child == entity>
		<#-- Parent relationship -->
		<#if relationship.identifying>
			:${f.att(relationship.parentAssociationName)}Id,
 		</#if>
 	<#else>
 		<#-- Child relationship -->
 		<#if !relationship.identifying>
			:${f.att(relationship.childAssociationName)}Id,
	 	</#if>
	 </#if>
</#list>
<#list entity.attributes as attribute>
			:${f.att(attribute.name)},
</#list>
			:version,
			:updateDatetime,
			:updateUid,
			:createDatetime,
			:createUid
		)
		]]>
	</sql>
	<sql key="update${f.cla(entity.name)}">
		<![CDATA[
		UPDATE ${f.tab(entity.name)}
		SET
<#list entity.relationships as relationship>
	<#if relationship.child == entity>
		<#-- Parent relationship -->
		<#if relationship.identifying>
			${f.col(relationship.parentAssociationName)}_id = :${f.att(relationship.parentAssociationName)}Id,
 		</#if>
 	<#else>
 		<#-- Child relationship -->
 		<#if !relationship.identifying>
			${f.col(relationship.childAssociationName)}_id = :${f.att(relationship.childAssociationName)}Id,
	 	</#if>
	 </#if>
</#list>
<#list entity.attributes as attribute>
			${f.col(attribute.name)} = :${f.att(attribute.name)},
</#list>
			version = (:version+1),
			update_datetime = :updateDatetime,
			update_uid = :updateUid,
			create_datetime = :createDatetime,
			create_uid = :createUid
		WHERE
			${f.col(entity.name)}_id = :${f.att(entity.name)}Id
		AND
			version = :version
		]]>
	</sql>
</sql-queries>
