<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=application -->
<#-- version=1.0 -->
<#-- fileNameTemplate=AbstractConverter.java -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=util.convert -->
<#-- END TEMPLATE HEADER -->
/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ$}}
 */

/*
${f.formatLines(project.copyright, ' * ', 80)}
 */
package ${project.rootPackage}.util.convert;

import org.apache.struts.util.MessageResources;

/**
 * Abstract implementation of the Converter class that handles the
 * initialisation by storing a reference to the MessageResources.
 */
public abstract class AbstractConverter implements Converter {

	/**
	 * Reference to the MessageResources used to initialise this.
	 */
	protected MessageResources resources;

	/**
	 * Store a reference to the message resources.
	 *
	 * @see au.com.codecanvas.generator.convert.Converter#init(org.apache.struts.util.MessageResources)
	 */
	public void init(MessageResources resources) {
		this.resources = resources;
	}

}
