<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=application -->
<#-- version=1.0 -->
<#-- fileNameTemplate=ActionException.java -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=util.action -->
<#-- END TEMPLATE HEADER -->
/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ$}}
 */

/*
${f.formatLines(project.copyright, ' * ', 80)}
 */
package ${project.rootPackage}.util.action;

import ${project.rootPackage}.util.ApplicationException;

/**
 * A custom ApplicationException for Action related exceptions.
 */
public class ActionException extends ApplicationException {

	/**
	 * The MISSING_REQUIRED_PARAMETER error key
	 */
	public static final String MISSING_REQUIRED_PARAMETER = "actionException.missingRequiredParameter";

	/**
	 * Construct a new ActionException
	 *
	 * @param key - identifying the exception type.
	 * @param args - additional information about the exception.
	 * @param cause - the root cause of the exception.
	 */
	public ActionException(String key, Object[] args, Throwable cause) {
		super(key, args, cause);
	}

	/**
	 * Construct a new ActionException
	 *
	 * @param key - identifying the exception type.
	 * @param arg - additional information about the exception.
	 * @param cause - the root cause of the exception.
	 */
	public ActionException(String key, Object arg, Throwable cause) {
		super(key, arg, cause);
	}

}
