<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=application -->
<#-- version=1.0 -->
<#-- fileNameTemplate=ApplicationProperties.java -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=util -->
<#-- END TEMPLATE HEADER -->
/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ$}}
 */

/*
${f.formatLines(project.copyright, ' * ', 80)}
 */
package ${project.rootPackage}.util;

/**
 * ApplicationProperties is a convenient extension to ExtendedProperties
 * that loads its properties from the "/application.properties" resource.
 */
public class ApplicationProperties extends ExtendedProperties {

	/**
	 * The userid used by DAO classes if no user is logged in.
	 */
	public static String DAO_GUESTUSERID = "dao.guestUserId";

	/**
	 * The JNDI name to lookup the datasource.
	 */
	public static String DATASOURCE_JNDINAME = "dataSource.jndiName";

	/**
	 * The key grab size for the sequence generator.
	 */
	public static final String SEQUENCEGENERATOR_GRABSIZE = "sequenceGenerator.grabSize";
<#list guiComponents as guiComponent>
	<#if guiComponent.isPagingEnabled()>

	/**
	 * The page size for the ${guiComponent.name}
	 */
	public static final String ${f.cla(guiComponent.name)?upper_case}_PAGESIZE = "${f.att(guiComponent.name)}.pageSize";
	</#if>
</#list>

	/**
	 * The ApplicationProperties.
	 */
	private static ApplicationProperties singleton = null;

	/**
	 * Private constructor to prevent external instatiation.
	 */
	private ApplicationProperties() {}

	/**
	 * Returns a shared lazy loaded ApplicationProperties instance.
	 *
	 * @return the singleton ApplicationProperties
	 */
	public static synchronized ApplicationProperties getInstance() {
		// Lazy load the singleton
		if (singleton==null) {
			// Create  a new ApplicationProperties instance
			ApplicationProperties temp = new ApplicationProperties();
			// Try and load it with the properties
			temp.load("/application.properties", ApplicationProperties.class);
			// The load was successful, it becomes the singleton
			singleton = temp;
		}
		return singleton;
	}

}
