<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=application -->
<#-- version=1.0 -->
<#-- fileNameTemplate=ApplicationResources.properties -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=. -->
<#-- END TEMPLATE HEADER -->
#
# Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
#
# Modification and redistribution of this file is permitted subject to the
# terms and conditions of the RapidJ End User License Agreement:
# http://www.codecanvas.com.au/rapidj/license.php
#
# {{$RapidJ$}}
#

#
${f.formatLines(project.copyright, '# ', 80)}
#

#
# Message Resources
#

# Application Messages
application.title=${project.applicationTitle}
application.description=<#if project.applicationDescription?exists>${project.applicationDescription}</#if>

# Common Messages
common.action=Action
common.add=Add New
common.back=Back
common.confirmDelete=Are you sure you want to delete this?
common.delete=Delete
common.deleteOk=Delete successful
common.edit=Edit
common.error=Error
common.home=Home
common.next=Next >>
common.none=None
common.page=Page
common.previous=<< Previous
common.save=Save
common.saveOk=Save successful
common.select=Select
common.timeTaken=Page took {0} milliseconds
common.true=Yes
common.false=No

# Common Fields
version.displayName=Version

#
# Formats used by Struts WriteTag
#
# Applies to java.sql.Timestamp
org.apache.struts.taglib.bean.format.sql.timestamp=yyyy-MM-dd HH:mm:ss
# Applies to java.sql.Date
org.apache.struts.taglib.bean.format.sql.date=dd/MM/yyyy
# Applies to java.sql.Time
org.apache.struts.taglib.bean.format.sql.time=HH:mm:ss
# Applies to java.util.Date
org.apache.struts.taglib.bean.format.date=dd/MM/yyyy
# Applies to Byte, Short, Integer, Long, BigInteger
# If not specified, the default format for the locale is used
#org.apache.struts.taglib.bean.format.int=
# Applies to Float, Double, BigDecimal
# If not specified, the default format for the locale is used
#org.apache.struts.taglib.bean.format.float=

# Global Exception Handler Message
global.error.message={0}

# Converter Formats
# Used to convert user input
basicByteConverter.formatKey=#
basicShortConverter.formatKey=#
basicIntegerConverter.formatKey=#
basicLongConverter.formatKey=#
basicFloatConverter.formatKey=#.#####
basicDoubleConverter.formatKey=#.#####
# If you change basicDateConverter.formatKey you will need to update validation.xml
# and the calendarTag.dateMask property below.
basicDateConverter.formatKey=dd/MM/yyyy
# If you change basicTimeConverter.formatKey you will need to update validation.xml
basicTimeConverter.formatKey=HH:mm:ss
# If you change basicTimestampConverter.formatKey you will need to update validation.xml
basicTimestampConverter.formatKey=yyyy-MM-dd HH:mm:ss

# Calendar Tag
# If you change calendarTag.dateMask you will need to update validation.xml
# and the basicDateConverter.formatKey property above.
calendarTag.dateMask=dd/MM/yyyy
calendarTag.dateMaskMissing=The date mask has not been specified for the CalendarTag

# Database Error Messages
databaseException.couldNotFindDataSource=Could not locate DataSource under JNDI name: {0}
databaseException.errorBeginningUserTransaction=Error beginning transaction: {0}
databaseException.errorCommittingUserTransaction=Error committing transaction: {0}
databaseException.errorLocatingDataSource=Error locating data source: {0}
databaseException.errorLocatingUserTransaction=Error locating transaction: {0}

# DAO Error Messages
daoException.concurrentUpdate=The {0} record for id {1} has been updated by someone else
daoException.deleteByIdAffectedMultipleRecords=Deleting {0} for ID {1} affects multiple records
daoException.deleteByIdAffectedNoRecords=Deleting {0} for ID {1} does not affect any records
daoException.errorCreatingTransferObject=Error exracting data: {0}
daoException.errorExtractingTransferObjects=Error exracting data: {0}
daoException.errorExtractingValue=Error extracting data: {0}
daoException.errorPopulatingTransferObject=Error exracting data: {0}
daoException.identifiedChildrenExist=This record references {0} records
daoException.recordDoesNotExist=No {0} records found for id {1}
daoException.selectByIdReturnedMultipleRecords=Found more than one {0} for id {1}
daoException.selectByIdReturnedNoRecords=No {0} records found for id {1}
daoException.selectByParentIdReturnedMultipleRecords=Found more than one {0} for {1} with id {2}
daoException.updateAffectedWrongNumberRecords=Updating {0} for id {1} affected the wrong number of records

# StatementPreparer Error Messages
statementPreparerException.missingResource=Missing resource {0}
statementPreparerException.errorReadingResource=Error reading resource {0}: {1}
statementPreparerException.missingSqlKey=No sql for sqlKey {0}

# Other Error Messages
copyException.copyError=Error copying data: {0}
templateException.processingError=Error processing template: {0}
actionException.missingRequiredParameter=Missing required parameter: {0}

# Struts Validator Error Messages
errors.byte={0} must be a byte.
errors.creditcard={0} is an invalid credit card number.
errors.date={0} is not a date.
errors.timestamp={0} is not a timestamp.
errors.time={0} is not a time.
errors.double={0} must be a double.
errors.email={0} is an invalid e-mail address.
errors.float={0} must be a float.
errors.integer={0} must be an integer.
errors.invalid={0} is invalid.
errors.long={0} must be a long.
errors.maxlength={0} can not be greater than {1} characters.
errors.minlength={0} can not be less than {1} characters.
errors.range={0} is not in the range {1} through {2}.
errors.required={0} is required.
errors.short={0} must be a short.
<#list guiComponents as guiComp>
	<#-- Setup some commonly used variables for the gui component -->
	<#-- NOTE: entityName has not been formatted -->
	<#if guiComp.identifyingRelationshipWithAncestor?exists>
		<#assign iRelationship = guiComp.identifyingRelationshipWithAncestor/>
		<#assign entityName = iRelationship.childAssociationName/>
	<#else>
		<#assign iRelationship = ""/>
		<#assign entityName = guiComp.entity.name/>
	</#if>
	<#assign guiCompNameA= f.att(guiComp.name)>

	<#switch guiComp.category>
		<#case GUIComponentStatics.CATEGORY_______LP>
			<#assign templateInclude = "/generic/includes/ApplicationResources_______LP.properties.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_EX_LC>
			<#assign templateInclude = "/generic/includes/ApplicationResources_LP_EX_LC.properties.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_DP_EX_LC>
			<#assign templateInclude = "/generic/includes/ApplicationResources_DP_EX_LC.properties.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_______DP>
			<#assign templateInclude = "/generic/includes/ApplicationResources_______DP.properties.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_EX_DP>
			<#assign templateInclude = "/generic/includes/ApplicationResources_LP_EX_DP.properties.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_EX_DC>
			<#assign templateInclude = "/generic/includes/ApplicationResources_LP_EX_DC.properties.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_DP_EX_DC>
			<#assign templateInclude = "/generic/includes/ApplicationResources_DP_EX_DC.properties.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_IN_LC>
			<#assign templateInclude = "/generic/includes/ApplicationResources_LP_IN_LC.properties.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_DP_IN_LC>
			<#assign templateInclude = "/generic/includes/ApplicationResources_DP_IN_LC.properties.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_IN_DP>
			<#assign templateInclude = "/generic/includes/ApplicationResources_LP_IN_DP.properties.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_IN_DC>
			<#assign templateInclude = "/generic/includes/ApplicationResources_LP_IN_DC.properties.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_DP_IN_DC>
			<#assign templateInclude = "/generic/includes/ApplicationResources_DP_IN_DC.properties.ftl"/>
			<#break>
	</#switch>
# ${f.cla(guiComp.name)} Messages  (Include from '${templateInclude}')
	<#if templateInclude != "">
		<#include templateInclude/>
	<#else>
		UNKNOWN CATEGORY OF GUICOMPONENT
	</#if>
</#list>

