<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=application -->
<#-- version=1.0 -->
<#-- fileNameTemplate=Converter.java -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=util.convert -->
<#-- END TEMPLATE HEADER -->
/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ$}}
 */

/*
${f.formatLines(project.copyright, ' * ', 80)}
 */
package ${project.rootPackage}.util.convert;

import java.util.Locale;

import org.apache.struts.util.MessageResources;

/**
 * Converters are used to convert data from one type to another. A single
 * converter may handle data conversions for many different types to many
 * other types, or it mayhandle conversion between two types.
 *
 * To use a Converters it should be registered with ConvertUtils for the
 * from and type types that it convert between.
 */
public interface Converter {

	/**
	 * Initialise this converter.
	 *
	 * @param resources - the MessageResources to use for initialisation. May
	 * be null.
	 */
	public void init(MessageResources resources);

	/**
	 * Asks the converter to convert the specified value from the toType to an
	 * object of the toType taking into account the locale.
	 *
	 * @param value the value to convert.
	 * @param fromType the type to treat the value as.
	 * @param toType the type to convert the value to.
	 * @param locale the Locale.
	 * @return the converted object.
	 */
	public Object convert(Object value, Class fromType, Class toType, Locale locale);

}
