<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=application -->
<#-- version=1.0 -->
<#-- fileNameTemplate=CopyException.java -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=util.copy -->
<#-- END TEMPLATE HEADER -->
/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ$}}
 */

/*
${f.formatLines(project.copyright, ' * ', 80)}
 */
package ${project.rootPackage}.util.copy;

import ${project.rootPackage}.util.ApplicationException;

/**
 * An ApplicationException contains an error key, optional related data and
 * optional cause of the Exception.
 */
public class CopyException extends ApplicationException {

	/**
	 * Error key for a copy error
	 */
	public static final String COPY_ERROR = "copyException.copyError";

	/**
	 * Construct a new CopyException
	 *
	 * @param key - identifying the exception type.
	 * @param args - additional information about the exception.
	 * @param cause - the root cause of the exception.
	 */
	public CopyException(String key, Object[] args, Throwable cause) {
		super(key, args, cause);
	}

}
