<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=application -->
<#-- version=1.0 -->
<#-- fileNameTemplate=DAOException.java -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=util.dao -->
<#-- END TEMPLATE HEADER -->
/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ$}}
 */

/*
${f.formatLines(project.copyright, ' * ', 80)}
 */
package ${project.rootPackage}.util.dao;

import ${project.rootPackage}.util.ApplicationException;

/**
 * A custom ApplicationException for Data Access related exceptions.
 */
public class DAOException extends ApplicationException {

	/**
	 * The IDENTIFIED_CHILDREN_EXIST error key
	 */
	public static final String IDENTIFIED_CHILDREN_EXIST = "daoException.identifiedChildrenExist";

	/**
	 * The CONCURRENT_UPDATE error key
	 */
	public static final String CONCURRENT_UPDATE = "daoException.concurrentUpdate";

	/**
	 * The RECORD_DOES_NOT_EXIST error key
	 */
	public static final String RECORD_DOES_NOT_EXIST = "daoException.recordDoesNotExist";

	/**
	 * The PAGE_DOES_NOT_EXIST error key
	 */
	public static final String PAGE_DOES_NOT_EXIST = "daoException.pageDoesNotExist";

	/**
	 * The ERROR_EXTRACTING_VALUE error key
	 */
	public static final String ERROR_EXTRACTING_VALUE = "daoException.errorExtractingValue";

	/**
	 * The ERROR_EXTRACTING_TRANSFER_OBJECTS error key
	 */
	public static final String ERROR_EXTRACTING_TRANSFER_OBJECTS = "daoException.errorExtractingTransferObjects";

	/**
	 * The SELECT_BY_ID_RETURNED_NO_RECORDS error key
	 */
	public static final String SELECT_BY_ID_RETURNED_NO_RECORDS = "daoException.selectByIdReturnedNoRecords";

	/**
	 * The SELECT_BY_ID_RETURNED_MULTIPLE_RECORDS error key
	 */
	public static final String SELECT_BY_ID_RETURNED_MULTIPLE_RECORDS = "daoException.selectByIdReturnedMultipleRecords";

	/**
	 * The SELECT_BY_PARENT_ID_RETURNED_MULTIPLE_RECORDS error key
	 */
	public static final String SELECT_BY_PARENT_ID_RETURNED_MULTIPLE_RECORDS = "daoException.selectByParentIdReturnedMultipleRecords";

	/**
	 * The DELETE_BY_ID_AFFECTED_MULTIPLE_RECORDS error key
	 */
	public static final String DELETE_BY_ID_AFFECTED_MULTIPLE_RECORDS = "daoException.deleteByIdAffectedMultipleRecords";

	/**
	 * The DELETE_BY_ID_AFFECTED_NO_RECORDS error key
	 */
	public static final String DELETE_BY_ID_AFFECTED_NO_RECORDS = "daoException.deleteByIdAffectedNoRecords";

	/**
	 * The UPDATE_AFFECTED_WRONG_NUMBER_RECORDS error key
	 */
	public static final String UPDATE_AFFECTED_WRONG_NUMBER_RECORDS = "daoException.updateAffectedWrongNumberRecords";

	/**
	 * The ERROR_CREATING_TRANSFER_OBJECT error key
	 */
	public static final String ERROR_CREATING_TRANSFER_OBJECT = "daoException.errorCreatingTransferObject";

	/**
	 * The ERROR_POPULATING_TRANSFER_OBJECT error key
	 */
	public static final String ERROR_POPULATING_TRANSFER_OBJECT = "daoException.errorPopulatingTransferObject";

	/**
	 * Construct a new DAOException
	 *
	 * @param key - identifying the exception type.
	 * @param args - additional information about the exception.
	 * @param cause - the root cause of the exception.
	 */
	public DAOException(String key, Object[] args, Throwable cause) {
		super(key, args, cause);
	}

	/**
	 * Construct a new DAOException
	 *
	 * @param key - identifying the exception type.
	 * @param arg - additional information about the exception.
	 * @param cause - the root cause of the exception.
	 */
	public DAOException(String key, Object arg, Throwable cause) {
		super(key, arg, cause);
	}

}
