<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=application -->
<#-- version=1.0 -->
<#-- fileNameTemplate=DAOs.java -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=data.dao -->
<#-- END TEMPLATE HEADER -->
/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ$}}
 */

/*
${f.formatLines(project.copyright, ' * ', 80)}
 */
package ${project.rootPackage}.data.dao;

import ${project.rootPackage}.util.database.StatementPreparerException;

/**
 * This class provides lazy loaded access to all DAO classes.
 */
public class DAOs {
<#list entities as entity>

	/**
	 * Reference to the ${f.cla(entity.name)}DAO
	 */
	private static ${f.cla(entity.name)}DAO ${f.att(entity.name)}DAO = null;
</#list>

	/**
	 * Default constructor
	 */
	private DAOs() {}
<#list entities as entity>

	/**
	 * Returns a lazy loaded ${f.cla(entity.name)}DAO.
	 *
	 * @exception StatementPreparerException
	 */
	public static ${f.cla(entity.name)}DAO get${f.cla(entity.name)}DAO() throws StatementPreparerException {
		if (${f.att(entity.name)}DAO==null) {
			${f.att(entity.name)}DAO = new ${f.cla(entity.name)}DAO();
		}
		return ${f.att(entity.name)}DAO;
	}
</#list>

}
