<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=application -->
<#-- version=1.0 -->
<#-- fileNameTemplate=DatabaseException.java -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=util.database-->
<#-- END TEMPLATE HEADER -->
/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ$}}
 */

/*
${f.formatLines(project.copyright, ' * ', 80)}
 */
package ${project.rootPackage}.util.database;

import ${project.rootPackage}.util.ApplicationException;

/**
 * A custom ApplicationException for database related exceptions.
 */
public class DatabaseException extends ApplicationException {

	/**
	 * The ERROR_LOCATING_USER_TRANSACTION error key
	 */
	public static final String ERROR_LOCATING_USER_TRANSACTION = "databaseException.errorLocatingUserTransaction";

	/**
	 * The ERROR_BEGINNING_USER_TRANSACTION error key
	 */
	public static final String ERROR_BEGINNING_USER_TRANSACTION = "databaseException.errorBeginningUserTransaction";

	/**
	 * The ERROR_COMMITTING_USER_TRANSACTION error key
	 */
	public static final String ERROR_COMMITTING_USER_TRANSACTION = "databaseException.errorCommittingUserTransaction";

	/**
	 * The ERROR_LOCATING_DATA_SOURCE error key
	 */
	public static final String ERROR_LOCATING_DATA_SOURCE = "databaseException.errorLocatingDataSource";

	/**
	 * The COULD_NOT_FIND_DATA_SOURCE error key
	 */
	public static final String COULD_NOT_FIND_DATA_SOURCE = "databaseException.couldNotFindDataSource";

	/**
	 * Construct a new DatabaseException
	 *
	 * @param key - identifying the exception type
	 * @param args - additional information related to the exception
	 * @param cause - the root cause of this exception
	 */
	public DatabaseException(String key, Object[] args, Throwable cause) {
		super(key, args, cause);
	}

	/**
	 * Construct a new DatabaseException
	 *
	 * @param key - identifying the exception type
	 * @param arg - additional information related to the exception
	 * @param cause - the root cause of this exception
	 */
	public DatabaseException(String key, Object arg, Throwable cause) {
		super(key, new Object[] {arg}, cause);
	}

}
