<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=application -->
<#-- version=1.0 -->
<#-- fileNameTemplate=Request.java -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=web.action -->
<#-- END TEMPLATE HEADER -->
/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ$}}
 */

/*
${f.formatLines(project.copyright, ' * ', 80)}
 */
package ${project.rootPackage}.web.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

/**
 * A wrapper class that encapsulates Action.execute() parameters.
 */
public class Request {

	public HttpServletRequest request;
	public HttpServletResponse response;
	public ActionMapping mapping;
	public ActionForm form;

	public Request(ActionMapping mapping,
				   ActionForm form,
				   HttpServletRequest request,
				   HttpServletResponse response) {

		this.mapping = mapping;
		this.form = form;
		this.request = request;
		this.response = response;
	}

	/**
	 * @return
	 */
	public ActionForm getForm() {
		return form;
	}

	/**
	 * @return
	 */
	public ActionMapping getMapping() {
		return mapping;
	}

	/**
	 * @return
	 */
	public HttpServletRequest getRequest() {
		return request;
	}

	/**
	 * @return
	 */
	public HttpServletResponse getResponse() {
		return response;
	}

	/**
	 * @param form
	 */
	public void setForm(ActionForm form) {
		this.form = form;
	}

	/**
	 * @param mapping
	 */
	public void setMapping(ActionMapping mapping) {
		this.mapping = mapping;
	}

	/**
	 * @param request
	 */
	public void setRequest(HttpServletRequest request) {
		this.request = request;
	}

	/**
	 * @param response
	 */
	public void setResponse(HttpServletResponse response) {
		this.response = response;
	}

}
