<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=application -->
<#-- version=1.0 -->
<#-- fileNameTemplate=StatementPreparerException.java -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=util.database-->
<#-- END TEMPLATE HEADER -->
/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ$}}
 */

/*
${f.formatLines(project.copyright, ' * ', 80)}
 */
package ${project.rootPackage}.util.database;

import ${project.rootPackage}.util.ApplicationException;

/**
 * A custom ApplicationException for StatementPreparer exceptions.
 */
public class StatementPreparerException extends ApplicationException {

	/**
	 * The MISSING_SQL_KEY error key
	 */
	public static final String MISSING_SQL_KEY = "statementPreparerException.missingSqlKey";

	/**
	 * The ERROR_READING_RESOURCE error key
	 */
	public static final String ERROR_READING_RESOURCE = "statementPreparerException.errorReadingResource";

	/**
	 * The MISSING_RESOURCE error key
	 */
	public static final String MISSING_RESOURCE = "statementPreparerException.missingResource";

	/**
	 * Construct a new StatementPreparerException
	 *
	 * @param key - identifying the exception type.
	 * @param args - additional information about the exception.
	 * @param cause - the root cause of the exception.
	 */
	public StatementPreparerException(String key, Object[] args, Throwable cause) {
		super(key, args, cause);
	}

	/**
	 * Construct a new StatementPreparerException
	 *
	 * @param key - identifying the exception type.
	 * @param arg - additional information about the exception.
	 * @param cause - the root cause of the exception.
	 */
	public StatementPreparerException(String key, Object arg, Throwable cause) {
		super(key, arg, cause);
	}

}
