<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=application -->
<#-- version=1.0 -->
<#-- fileNameTemplate=TemplateException.java -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=util.template -->
<#-- END TEMPLATE HEADER -->
/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ$}}
 */

/*
${f.formatLines(project.copyright, ' * ', 80)}
 */
package ${project.rootPackage}.util.template;

import ${project.rootPackage}.util.ApplicationException;

/**
 * TemplateException
 */
public class TemplateException extends ApplicationException {

	/**
	 * Error key for a processing error
	 */
	public static final String PROCESSING_ERROR = "templateException.processingError";

	/**
	 * Construct a new TemplateException
	 *
	 * @param key - identifying the exception type
	 * @param args - additional information related to the exception
	 * @param cause - the root cause of this exception
	 */
	public TemplateException(String key, Object[] args, Throwable cause) {
		super(key, args, cause);
	}

	/**
	 * Construct a new TemplateException
	 *
	 * @param key - identifying the exception type
	 * @param arg - additional information related to the exception
	 * @param cause - the root cause of this exception
	 */
	public TemplateException(String key, Object arg, Throwable cause) {
		super(key, new Object[] {arg}, cause);
	}

}
