<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=application -->
<#-- version=1.0 -->
<#-- fileNameTemplate=common.js -->
<#-- relativeOutputDirectory=web -->
<#-- END TEMPLATE HEADER -->
/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ$}}
 */

/*
${f.formatLines(project.copyright, ' * ', 80)}
 */

/**
 * Sets the forms action using the specified action, optional additional
 * parameter and value, and optional anchor.
 *
 * @param form - the form to submit (required).
 * @param action - the action relative to the current location (required).
 * @param dispatch - the value of the dispatch request parameter (optional).
 * @param param1 - name of an additional parameter (optional).
 * @param value1 - value of the additional parameter.
 * @param anchor - the html anchor
 */
function doPost(form, action, dispatch, param1, value1, anchor) {

	// Get the form action url
	var url = constructURL(action, dispatch, param1, value1, anchor);

	// Set it on the form and submit
	form.action = url;
	form.submit();

}

/**
 * Change the document location.
 *
 * @param action - the action relative to the current location (required).
 * @param dispatch - the value of the dispatch request parameter (optional).
 * @param param1 - name of an additional parameter (optional).
 * @param value1 - value of the additional parameter.
 * @param anchor - the html anchor
 */
function doGet(action, dispatch, param1, value1, anchor) {

	// Get the url
	var url = constructURL(action, dispatch, param1, value1, anchor);

	// Set the document location
	document.location=url;

}

/**
 * Constructs a url using the provided information.
 *
 * @param action - the action relative to the current location (required).
 * @param dispatch - the value of the dispatch request parameter (optional).
 * @param param1 - name of an additional parameter (optional).
 * @param value1 - value of the additional parameter.
 * @param anchor - the html anchor
 */
function constructURL(action, dispatch, param1, value1, anchor) {

	var url = action;
	var nextSeperator = '?';
	if (dispatch != null) {
		url += (nextSeperator + 'dispatch=' + escape(dispatch));
		nextSeperator = '&';
	}
	if (param1 != null) {
		url += (nextSeperator + escape(param1) + '=' + escape(value1));
	}
	if (anchor != null) {
		url += '#' + escape(anchor);
	}
	return url;

}

/**
 * Locates a form element with the specifed name in any of the forms in the
 * current document.
 *
 * @param formName - the name of the form.
 * @return the named form, or null if not found.
 */
function getDocumentFormElement(formName) {
	for (var i = 0; i < document.forms.length; i++) {
		var form = document.forms[i];
		if (form[formName]!=null) {
			//alert('found '+ form[formName]);
			return form[formName];
		}
	}
	alert('no element for formName='+ formName);
	return null;
}
