<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=application -->
<#-- version=1.0 -->
<#-- fileNameTemplate=validation.xml -->
<#-- relativeOutputDirectory=web/WEB-INF -->
<#-- END TEMPLATE HEADER -->
<?xml version="1.0" encoding="ISO-8859-1" ?>

<!DOCTYPE form-validation PUBLIC
          "-//Apache Software Foundation//DTD Commons Validator Rules Configuration 1.0//EN"
          "http://jakarta.apache.org/commons/dtds/validator_1_0.dtd">

<!--

  Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.

  Modification and redistribution of this file is permitted subject to the
  terms and conditions of the RapidJ End User License Agreement:
  http://www.codecanvas.com.au/rapidj/license.php

  {{$RapidJ$}}

-->

<!--

${f.formatLines(project.copyright, '  ', 80)}

-->

<form-validation>

  <global>
    <!--

      A good resource for understanding and creating regular expressions is
      http://www.sweeting.org/mark/html/revalid.php

    -->
    <constant>
      <constant-name>defaultBigDecimalMask</constant-name>
      <constant-value>^[+-]?\d{0,10}(\.\d{1,4})?$</constant-value>
    </constant>
    <constant>
      <constant-name>defaultDatePatternStrict</constant-name>
      <!--

        Any changes to this value will need to be applied to the application
        properties "basicDateConverter.formatKey" and "calendarTag.dateMask"

      -->
      <constant-value>dd/MM/yyyy</constant-value>
    </constant>
    <constant>
      <constant-name>defaultTimestampPattern</constant-name>
      <!--

        Any changes to this value will need to be applied to the application
        property "basicTimestampConverter.formatKey" and also the "defaultTimestampMask"
        constant value in this file may need to be updated.

      -->
      <constant-value>yyyy-MM-dd HH:mm:ss</constant-value>
    </constant>
    <constant>
      <constant-name>defaultTimestampMask</constant-name>
      <constant-value>^\d*-\d{2}-\d{2} \d{2}:\d{2}:\d{2}$</constant-value>
    </constant>
    <constant>
      <constant-name>defaultTimePattern</constant-name>
      <!--

        Any changes to this value will need to be applied to the application
        property "basicTimeConverter.formatKey" and also the "defaultTimeMask"
        constant value in this file may need to be updated.

      -->
      <constant-value>HH:mm:ss</constant-value>
    </constant>
    <constant>
      <constant-name>defaultTimeMask</constant-name>
      <constant-value>^\d{2}:\d{2}:\d{2}$</constant-value>
    </constant>
  ${r"</global>"}
  <formset>
<#list guiComponents as guiComponent>
	<#if !guiComponent.internalParent?exists && (guiComponent.isDetail() || guiComponent.hasInternalDetailDescendant())>
    <form name="${f.att(guiComponent.name)}Form">
      	<#if guiComponent.isDetail()>
			<@generateFormValidation guiComp=guiComponent/>
		</#if>
		<#list guiComponent.allInternalDetailChildren as child>
			<@generateFormValidation guiComp=child/>
		</#list>
    </form>
	</#if>
</#list>
<#macro generateFormValidation (guiComp)>
	<#-- Determine the identifying parent relationship and the entity name to use -->
	<#if guiComp.identifyingRelationshipWithAncestor?exists>
		<#assign iRelationship = guiComp.identifyingRelationshipWithAncestor/>
		<#assign entityName = f.cla(iRelationship.childAssociationName)/>
	<#else>
		<#assign iRelationship = ""/>
		<#assign entityName = f.cla(guiComp.entity.name)/>
	</#if>
	<#list guiComp.entity.identifyingRelationshipsWithParents as relationship>
		<#if relationship != iRelationship && (!guiComp.isMultiDetail() || relationship.isOneToMany())>
			<#if guiComp.isMultiDetail()>
      <field property="${f.att(relationship.parentAssociationName)}Id" indexedListProperty="${f.att(guiComp.name)}${entityName}FOs" depends="required,">
			<#else>
      <field property="${f.att(guiComp.name)}${entityName}FO.${f.att(relationship.parentAssociationName)}Id" depends="ifparentpresent,required,">
			</#if>
        <arg0 key="${f.att(guiComp.name)}.${f.att(relationship.parentAssociationName)}.displayName"/>
      </field>
		</#if>
	</#list>
	<#list guiComp.visibleEditableDetailFields as detailField>
		<#assign attribute = detailField.attribute/>
		<#if guiComp.isMultiDetail()>
      <field property="${f.att(attribute.name)}" indexedListProperty="${f.att(guiComp.name)}${entityName}FOs" depends="<#rt>
		<#else>
      <field property="${f.att(guiComp.name)}${entityName}FO.${f.att(attribute.name)}" depends="ifparentpresent,<#rt>
		</#if>
		<#if detailField.required>
			<#lt>required,<#rt>
		</#if>
		<#assign javaType = attribute.javaType>
		<#if javaType == 'java.lang.String'>
			<#lt>maxlength,<#rt>
		<#elseif javaType == 'java.lang.Integer'>
			<#lt>integer,<#rt>
		<#elseif javaType == 'java.lang.Long'>
			<#lt>long,<#rt>
		<#elseif javaType == 'java.lang.Float'>
			<#lt>float,<#rt>
		<#elseif javaType == 'java.lang.Double'>
			<#lt>double,<#rt>
		<#elseif javaType == 'java.sql.Date'>
			<#lt>date,<#rt>
		<#elseif javaType == 'java.sql.Timestamp'>
			<#lt>mask,timestamp,<#rt>
		<#elseif javaType == 'java.sql.Time'>
			<#lt>mask,time,<#rt>
		<#elseif javaType == 'java.lang.Byte'>
			<#lt>byte,<#rt>
		<#elseif javaType == 'java.lang.Short'>
			<#lt>short,<#rt>
		<#elseif javaType == 'java.math.BigDecimal'>
			<#lt>mask,<#rt>
		</#if>
		<#lt>">
        <arg0 key="${f.att(guiComp.name)}.${f.att(attribute.name)}.displayName"/>
        <#if javaType == 'java.lang.String'>
        <arg1 name="maxlength" key="${r"${var:maxlength}"}" resource="false"/>
        <var>
          <var-name>maxlength</var-name>
          <var-value>${attribute.size}</var-value>
        </var>
		<#elseif javaType == 'java.math.BigDecimal'>
        <var>
          <var-name>mask</var-name>
          <var-value>${r"${defaultBigDecimalMask"}}</var-value>
        </var>
		<#elseif javaType == 'java.sql.Date'>
        <var>
          <var-name>datePatternStrict</var-name>
          <var-value>${r"${defaultDatePatternStrict}"}</var-value>
        </var>
		<#elseif javaType == 'java.sql.Timestamp'>
        <var>
          <var-name>datePattern</var-name>
          <var-value>${r"${defaultTimestampPattern}"}</var-value>
        </var>
        <var>
          <var-name>mask</var-name>
          <var-value>${r"${defaultTimestampMask"}}</var-value>
        </var>
		<#elseif javaType == 'java.sql.Time'>
        <var>
          <var-name>datePattern</var-name>
          <var-value>${r"${defaultTimePattern}"}</var-value>
        </var>
        <var>
          <var-name>mask</var-name>
          <var-value>${r"${defaultTimeMask"}}</var-value>
        </var>
		</#if>
      </field>
	</#list>
	<#if guiComp.isMultiDetail()>
      <field property="version" indexedListProperty="${f.att(guiComp.name)}${entityName}FOs" depends="long">
	<#else>
      <field property="${f.att(guiComp.name)}${entityName}FO.version" depends="ifparentpresent,long">
	</#if>
        <arg0 key="version.displayName"/>
      </field>
</#macro>
  </formset>
</form-validation>
