<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=entity -->
<#-- version=1.0 -->
<#-- fileNameTemplate=${f.cla(entity.name)}DSO.java -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=data.dso -->
<#-- END TEMPLATE HEADER -->
/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ$}}
 */

/*
${f.formatLines(project.copyright, ' * ', 80)}
 */
package ${project.rootPackage}.data.dso;

/**
 * <p>A Data Specification Object (DSO) specifies for an object which of
 * its related objects should be considered for some operation.
 *
 * <p>For example, it could be used to specify what related objects should
 * be loaded for a particular object.
 */
public class ${f.cla(entity.name)}DSO {
<#list entity.relationships as relationship>
	<#if entity == relationship.parent>
		<#-- Child relationships -->

	/**
	 * Specifies how the related ${f.cla(relationship.childAssociationName)} should be considered
	 */
	private ${f.cla(relationship.child.name)}DSO ${f.att(relationship.childAssociationName)}DSO;
	</#if>
</#list>

	/**
	 * Default constructor
	 */
	public ${f.cla(entity.name)}DSO() {

	}
<#list entity.relationships as relationship>
	<#if entity == relationship.parent>
		<#-- Child relationships -->

	/**
	 * Returns the ${f.cla(relationship.childAssociationName)}DSO for this.
	 *
	 * @return
	 */
	public ${f.cla(relationship.child.name)}DSO get${f.cla(relationship.childAssociationName)}DSO() {
		return ${f.att(relationship.childAssociationName)}DSO;
	}

	/**
	 * Sets the ${f.cla(relationship.childAssociationName)}DSO for this.
	 *
	 * @param ${f.cla(relationship.childAssociationName)}DSO - for the related ${f.cla(relationship.childAssociationName)}
	 */
	public void set${f.cla(relationship.childAssociationName)}DSO(${f.cla(relationship.child.name)}DSO ${f.att(relationship.childAssociationName)}DSO) {
		this.${f.att(relationship.childAssociationName)}DSO = ${f.att(relationship.childAssociationName)}DSO;
	}
	</#if>
</#list>

}
