<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=entity -->
<#-- version=1.0 -->
<#-- fileNameTemplate=${f.cla(entity.name)}TO.java -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=data.to -->
<#-- END TEMPLATE HEADER -->
/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ$}}
 */

/*
${f.formatLines(project.copyright, ' * ', 80)}
 */
package ${project.rootPackage}.data.to;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;

import ${project.rootPackage}.data.dao.Versionable;

/**
 * A Transfer Object for ${f.cla(entity.name)} data.
 */
public class ${f.cla(entity.name)}TO implements Serializable, Cloneable, Versionable {

	private Long ${f.att(entity.name)}Id;
<#list entity.relationships as relationship>
	<#if entity == relationship.child>
		<#-- Parent relationships -->
	private Long ${f.att(relationship.parentAssociationName)}Id;
	<#else>
		<#-- Child relationships -->
		<#if relationship.isOneToOne()>
			<#if relationship.identifying>
	private ${f.cla(relationship.child.name)}TO ${f.att(relationship.childAssociationName)};
			<#else>
	private Long ${f.att(relationship.childAssociationName)}Id;
			</#if>
		<#else>
	private ArrayList ${f.att(relationship.childAssociationName)};
		</#if>
	</#if>
</#list>
<#list entity.attributes as attribute>
	private ${attribute.javaType} ${f.att(attribute.name)};
</#list>
	private Long version;
	private Timestamp updateDatetime;
	private String updateUid;
	private Timestamp createDatetime;
	private String createUid;

	/**
	 * @return
	 */
	public Long get${f.cla(entity.name)}Id() {
		return ${f.att(entity.name)}Id;
	}

	/**
	 * @param long1
	 */
	public void set${f.cla(entity.name)}Id(Long long1) {
		${f.att(entity.name)}Id = long1;
	}
<#list entity.relationships as relationship>
	<#if entity == relationship.child>
		<#-- Parent relationships -->

	/**
	 * @return
	 */
	public Long get${f.cla(relationship.parentAssociationName)}Id() {
		return ${f.att(relationship.parentAssociationName)}Id;
	}

	/**
	 * @param long1
	 */
	public void set${f.cla(relationship.parentAssociationName)}Id(Long long1) {
		${f.att(relationship.parentAssociationName)}Id = long1;
	}
	<#else>
		<#-- Child relationships -->
		<#if relationship.isOneToOne()>
			<#if relationship.identifying>

	/**
	 * @return
	 */
	public ${f.cla(relationship.child.name)}TO get${f.cla(relationship.childAssociationName)}() {
		return ${f.att(relationship.childAssociationName)};
	}

	/**
	 * @param ${f.att(relationship.child.name)}TO
	 */
	public void set${f.cla(relationship.childAssociationName)}(${f.cla(relationship.child.name)}TO ${f.att(relationship.childAssociationName)}TO) {
		${f.att(relationship.childAssociationName)} = ${f.att(relationship.childAssociationName)}TO;
	}
			<#else>

	/**
	 * @return
	 */
	public Long get${f.cla(relationship.childAssociationName)}Id() {
		return ${f.att(relationship.childAssociationName)}Id;
	}

	/**
	 * @param ${f.att(relationship.child.name)}Id
	 */
	public void set${f.cla(relationship.childAssociationName)}Id(Long ${f.att(relationship.childAssociationName)}Id) {
		this.${f.att(relationship.childAssociationName)}Id = ${f.att(relationship.childAssociationName)}Id;
	}
			</#if>
		<#else>

	/**
	 * @return
	 */
	public ArrayList get${f.cla(relationship.childAssociationName)}() {
		return ${f.att(relationship.childAssociationName)};
	}

	/**
	 * @param list
	 */
	public void set${f.cla(relationship.childAssociationName)}(ArrayList ${f.att(relationship.childAssociationName)}) {
		this.${f.att(relationship.childAssociationName)} = ${f.att(relationship.childAssociationName)};
	}
		</#if>
	</#if>
</#list>
<#list entity.attributes as attribute>

	/**
	 * @return
	 */
	public ${attribute.javaType} get${f.cla(attribute.name)}() {
		return ${f.att(attribute.name)};
	}

	/**
	 * @param string
	 */
	public void set${f.cla(attribute.name)}(${attribute.javaType} ${f.att(attribute.name)}) {
		this.${f.att(attribute.name)} = ${f.att(attribute.name)};
	}
</#list>

	/**
	 * @return
	 */
	public Timestamp getCreateDatetime() {
		return createDatetime;
	}

	/**
	 * @return
	 */
	public String getCreateUid() {
		return createUid;
	}

	/**
	 * @return
	 */
	public Timestamp getUpdateDatetime() {
		return updateDatetime;
	}

	/**
	 * @return
	 */
	public String getUpdateUid() {
		return updateUid;
	}

	/**
	 * @param timestamp
	 */
	public void setCreateDatetime(Timestamp timestamp) {
		createDatetime = timestamp;
	}

	/**
	 * @param string
	 */
	public void setCreateUid(String string) {
		createUid = string;
	}

	/**
	 * @param timestamp
	 */
	public void setUpdateDatetime(Timestamp timestamp) {
		updateDatetime = timestamp;
	}

	/**
	 * @param string
	 */
	public void setUpdateUid(String string) {
		updateUid = string;
	}

	/**
	 * @return
	 */
	public Long getVersion() {
		return version;
	}

	/**
	 * @param long1
	 */
	public void setVersion(Long long1) {
		version = long1;
	}

	/**
	 * Returns true if the specified object is not null, of the
	 * same type and the IDs are equal.
	 */
	public boolean equals(Object object) {
		if ((object != null) && (object instanceof ${f.cla(entity.name)}TO)) {
			if (${f.att(entity.name)}Id == null) {
				return (((${f.cla(entity.name)}TO) object).get${f.cla(entity.name)}Id() == null);
			} else {
				return (
					${f.att(entity.name)}Id.equals(((${f.cla(entity.name)}TO) object).get${f.cla(entity.name)}Id()));
			}
		} else {
			return false;
		}
	}

	/**
	 * Returns a hash code for this object using its id.
	 */
	public int hashCode() {
		if (${f.att(entity.name)}Id == null) {
			return -1;
		} else {
			return ${f.att(entity.name)}Id.intValue();
		}
	}

	/**
	 * Returns a String representation of this object using
	 * Object.toString() and all of its simple attributes.
	 */
	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append("[").append(super.toString()).append("{");
		buf.append(" ${f.att(entity.name)}Id=").append(${f.att(entity.name)}Id);
<#list entity.relationships as relationship>
	<#if entity == relationship.child>
		buf.append(", ${f.att(relationship.parentAssociationName)}Id=").append(${f.att(relationship.parentAssociationName)}Id);
	<#elseif relationship.isOneToOne() && !relationship.identifying>
		buf.append(", ${f.att(relationship.childAssociationName)}Id=").append(${f.att(relationship.childAssociationName)}Id);
	</#if>
</#list>
<#list entity.attributes as attribute>
		buf.append(", ${f.att(attribute.name)}=").append(${f.att(attribute.name)});
</#list>
		buf.append(", version=").append(version);
		buf.append(", updateDatetime=").append(updateDatetime);
		buf.append(", updateUid=").append(updateUid);
		buf.append(", createDatetime=").append(createDatetime);
		buf.append(", createUid=").append(createUid);
		buf.append("}]");
		return buf.toString();
	}

	/**
	 * Returns a clone of this object.
	 *
	 * Note: this is a shallow copy except for any mutable
	 * simple attributes which are also cloned. (Meaning
	 * that the clone references the non simple attributes)
	 */
	public Object clone() {
		${f.cla(entity.name)}TO clone = null;
		try {
			clone = (${f.cla(entity.name)}TO) super.clone();
			if (updateDatetime!=null) {
				clone.setUpdateDatetime((Timestamp)updateDatetime.clone());
			}
			if (createDatetime!=null) {
				clone.setCreateDatetime((Timestamp)createDatetime.clone());
			}
		} catch (CloneNotSupportedException e) {
			// This should never happen..
			throw new InternalError(e.getMessage());
		}
		return clone;
	}

}
