<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=gui -->
<#-- version=1.0 -->
<#-- fileNameTemplate=${f.cla(guiComponent.name)}Action.java -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=web.action -->
<#-- condition=${(!guiComponent.internalParent?exists)?string} -->
<#-- END TEMPLATE HEADER -->
<#assign formType = (f.cla(guiComponent.name) + "Form")>
/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ$}}
 */

/*
${f.formatLines(project.copyright, ' * ', 80)}
 */
package ${project.rootPackage}.web.action;

import java.util.ArrayList;
import java.util.Iterator;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForward;

import ${project.rootPackage}.data.dao.DAOs;
import ${project.rootPackage}.data.dso.*;
import ${project.rootPackage}.data.to.*;
import ${project.rootPackage}.util.dao.PagedData;
import ${project.rootPackage}.util.ApplicationProperties;
import ${project.rootPackage}.util.action.ActionException;
import ${project.rootPackage}.util.database.DatabaseUtils;
import ${project.rootPackage}.util.identity.IdentityUtils;
import ${project.rootPackage}.web.form.${f.cla(guiComponent.name)}Form;
import ${project.rootPackage}.web.fo.*;

/**
 * This Action class manages ${f.cla(guiComponent.name)}s.
 */
public class ${f.cla(guiComponent.name)}Action extends ActionBase {

	/**
	 * Log4J Logger for this class
	 */
	public static final Logger logger = Logger.getLogger(${f.cla(guiComponent.name)}Action.class);

	/**
	 * Delegates to the top level method for this action.
	 *
	 * @param request - the current Request.
	 * @param form - the form.
	 */
	public void executeDefault(Request request, ${formType} form) throws Exception {
<#if guiComponent.isList()>
		execute${f.cla(guiComponent.name)}List(request, form);
<#elseif guiComponent.isDetail()>
		execute${f.cla(guiComponent.name)}Edit(request, form);
</#if>
	}
<#-- Create a save method for this action. Will save all data for the Detail gui components -->
<#if guiComponent.isDetail() || guiComponent.hasInternalDetailDescendant()>

	/**
	 * Saves all details on the form.
	 *
	 * @param request - the current Request.
	 * @param form - containing the data to be saved.
	 */
	public ActionForward executeSave(Request request, ${formType} form) throws Exception {

		// Make sure the form was successfully validated
		if (isCancelled(request.getRequest())) {
		    // Validation was cancelled, but save was still called.
		    // Under normal circumstances this should not happen.
			throw new IllegalStateException("Validation cancelled for save");

		} else if (!request.getMapping().getValidate()) {
			// The form has not been validated yet, foward to this method
			// through a mapping that does have validation.
			return request.getMapping().findForward("validate");

		}

		// The form has been successfully validated.
		logger.debug("form succesfully validated, processing save..");

		try {

			// Begin the transaction
			DatabaseUtils.begin();

			// Save from the top level
			save${f.cla(guiComponent.name)}(request, form);

			// Commit the transaction
			DatabaseUtils.commit();

		} catch (Exception e) {
			// Rollback the transaction and throw exception on.
			DatabaseUtils.rollback();
			throw e;
		}

		// Add a save successfull message
		addGlobalMessage(request, "common.saveOk");

		// Execute the top level method
		executeDefault(request, form);

		// Forward to the success page
		return request.getMapping().findForward("success");

	}
</#if>
<#macro generateActionMethodsForGUIComponent guiComp>
	<#-- Setup some commonly used variables for the gui component -->
	<#if guiComp.identifyingRelationshipWithAncestor?exists>
		<#assign iRelationship = guiComp.identifyingRelationshipWithAncestor/>
		<#assign parentEntityName = f.cla(iRelationship.parentAssociationName)/>
		<#assign entityName = f.cla(iRelationship.childAssociationName)/>
	<#else>
		<#assign iRelationship = ""/>
		<#assign parentEntityName = ""/>
		<#assign entityName = f.cla(guiComp.entity.name)/>
	</#if>
	<#assign guiCompName = f.cla(guiComp.name)>
	<#assign guiCompNameA= f.att(guiComp.name)>

	// ---- Start ${guiCompName} Component Methods ----
	<#switch guiComp.category>
		<#case GUIComponentStatics.CATEGORY_______LP>
			<#assign templateInclude = "/generic/includes/Action_______LP.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_EX_LC>
			<#assign templateInclude = "/generic/includes/Action_LP_EX_LC.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_DP_EX_LC>
			<#assign templateInclude = "/generic/includes/Action_DP_EX_LC.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_______DP>
			<#assign templateInclude = "/generic/includes/Action_______DP.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_EX_DP>
			<#assign templateInclude = "/generic/includes/Action_LP_EX_DP.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_EX_DC>
			<#assign templateInclude = "/generic/includes/Action_LP_EX_DC.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_DP_EX_DC>
			<#assign templateInclude = "/generic/includes/Action_DP_EX_DC.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_IN_LC>
			<#assign templateInclude = "/generic/includes/Action_LP_IN_LC.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_DP_IN_LC>
			<#assign templateInclude = "/generic/includes/Action_DP_IN_LC.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_IN_DP>
			<#assign templateInclude = "/generic/includes/Action_LP_IN_DP.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_IN_DC>
			<#assign templateInclude = "/generic/includes/Action_LP_IN_DC.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_DP_IN_DC>
			<#assign templateInclude = "/generic/includes/Action_DP_IN_DC.java.ftl"/>
			<#break>
	</#switch>

	// Include from '${templateInclude}'
	<#if templateInclude != "">
		<#include templateInclude/>
	<#else>
		UNKNOWN CATEGORY OF GUICOMPONENT
	</#if>

	// ---- End ${guiCompName} Component Methods ----

	<#list guiComp.internalChildren as child>
		<@generateActionMethodsForGUIComponent guiComp=child/>
	</#list>
</#macro>
<#-- Call the macro with the top level gui component -->
<@generateActionMethodsForGUIComponent guiComp=guiComponent/>

}
