<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=gui -->
<#-- version=1.0 -->
<#-- fileNameTemplate=${f.cla(guiComponent.name)}${f.cla(guiComponent.entity.name)}FO.java -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=web.fo -->
<#-- condition=${guiComponent.isDetail()?string} -->
<#-- END TEMPLATE HEADER -->
<#import "/generic/includes/common.ftl" as common>
<#assign entity = guiComponent.entity/>
/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ$}}
 */

/*
${f.formatLines(project.copyright, ' * ', 80)}
 */
package ${project.rootPackage}.web.fo;

import java.io.Serializable;
import java.util.ArrayList;

import ${project.rootPackage}.util.identity.Identifiable;

/**
 * An editable Form Object (FO) for ${f.cla(entity.name)} records in the
 * ${f.cla(guiComponent.name)} gui component.
 */
public class ${f.cla(guiComponent.name)}${f.cla(entity.name)}FO implements Serializable, Cloneable, Identifiable {

<#-- Attributes -->
	/**
	 * Indentifies this
	 */
	private Long ${f.att(entity.name)}Id;
<#-- Related Parent Ids -->
<#if guiComponent.identifyingRelationshipWithAncestor?exists>
	<#assign iRelationship = guiComponent.identifyingRelationshipWithAncestor/>
<#else>
	<#assign iRelationship = ""/>
</#if>
<#list guiComponent.entity.identifyingRelationshipsWithParents as relationship>
	<#if relationship != iRelationship && (!guiComponent.isMultiDetail() || relationship.isOneToMany())>

	/**
	 * The id of the ${f.cla(relationship.parentAssociationName)} for this
	 */
	private String ${f.att(relationship.parentAssociationName)}Id;
	</#if>
</#list>
<#-- Related Children Ids -->
<#list entity.nonIdentifyingRelationshipsWithChildren as relationship>

	/**
	 * The id of the ${f.cla(relationship.childAssociationName)} for this
	 */
	private String ${f.att(relationship.childAssociationName)}Id;
</#list>
<#-- Editable Fields -->
<#list guiComponent.editableDetailFields as detailField>
	<#assign attribute = detailField.attribute/>

	/**
	 * The ${f.att(attribute.name)} property
	 */
	private String ${f.att(attribute.name)};
</#list>

	/**
	 * The version of data this contains
	 */
	private String version;
<#-- Getters and Setters -->

	/**
	 * Returns the id for this
	 *
	 * @return
	 */
	public Long get${f.cla(entity.name)}Id() {
		return ${f.att(entity.name)}Id;
	}

	/**
	 * Returns the id for this (Identifiable implementation)
	 *
	 * @return
	 */
	public Long getId() {
		return get${f.cla(entity.name)}Id();
	}

	/**
	 * Sets the id for this
	 *
	 * @param ${f.att(entity.name)}Id - the new id
	 */
	public void set${f.cla(entity.name)}Id(Long ${f.att(entity.name)}Id) {
		this.${f.att(entity.name)}Id = ${f.att(entity.name)}Id;
	}
<#-- Related Parent Ids -->
<#list guiComponent.entity.identifyingRelationshipsWithParents as relationship>
	<#if relationship != iRelationship && (!guiComponent.isMultiDetail() || relationship.isOneToMany())>
		<@common.generateGetterSetter name="${f.att(relationship.parentAssociationName)}Id" type="String"/>
	</#if>
</#list>
<#-- Related Children Ids -->
<#list entity.nonIdentifyingRelationshipsWithChildren as relationship>
	<@common.generateGetterSetter name="${f.att(relationship.childAssociationName)}Id"  type="String"/>
</#list>
<#-- Editable Fields -->
<#list guiComponent.editableDetailFields as detailField>
	<#assign attribute = detailField.attribute/>
	<@common.generateGetterSetter name="${f.att(attribute.name)}"  type="String"/>
</#list>

	/**
	 * Gets the version for this
	 *
	 * @return
	 */
	public String getVersion() {
		return version;
	}

	/**
	 * Sets the version for this
	 *
	 * @param version
	 */
	public void setVersion(String version) {
		this.version = version;
	}

	/**
	 * Returns a shallow copy of this object.
	 */
	public Object clone() {
		try {
			return (${f.cla(guiComponent.name)}${f.cla(entity.name)}FO) super.clone();
		} catch (CloneNotSupportedException e) {
			// This should never happen..
			throw new InternalError(e.getMessage());
		}
	}

	/**
	 * Returns a String representation of this object using all of its simple
	 * attributes.
	 *
	 * @return a String representation of this
	 */
	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append("[").append(super.toString()).append("{");
		buf.append(" ${f.att(entity.name)}Id=").append(${f.att(entity.name)}Id);
<#-- Related Parent Ids -->
<#list guiComponent.entity.identifyingRelationshipsWithParents as relationship>
	<#if relationship != iRelationship && (!guiComponent.isMultiDetail() || relationship.isOneToMany())>
		buf.append(", ${f.att(relationship.parentAssociationName)}Id=").append(${f.att(relationship.parentAssociationName)}Id);
	</#if>
</#list>
<#-- Related Child Ids -->
<#list entity.nonIdentifyingRelationshipsWithChildren as relationship>
		buf.append(", ${f.att(relationship.childAssociationName)}Id=").append(${f.att(relationship.childAssociationName)}Id);
</#list>
<#-- Editable Fields -->
<#list guiComponent.editableDetailFields as detailField>
	<#assign attribute = detailField.attribute/>
		buf.append(", ${f.att(attribute.name)}=").append(${f.att(attribute.name)});
</#list>
		buf.append(", version=").append(version);
		buf.append("}]");
		return buf.toString();
	}

}
