<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=gui -->
<#-- version=1.0 -->
<#-- fileNameTemplate=${f.cla(guiComponent.name)}Form.java -->
<#-- relativeOutputDirectory=src -->
<#-- relativePackage=web.form -->
<#-- condition=${(!guiComponent.internalParent?exists)?string} -->
<#-- END TEMPLATE HEADER -->
<#import "/generic/includes/common.ftl" as common>
/*
 * Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.
 *
 * Modification and redistribution of this file is permitted subject to the
 * terms and conditions of the RapidJ End User License Agreement:
 * http://www.codecanvas.com.au/rapidj/license.php
 *
 * {{$RapidJ$}}
 */

/*
${f.formatLines(project.copyright, ' * ', 80)}
 */
package ${project.rootPackage}.web.form;

import java.util.ArrayList;

import org.apache.log4j.Logger;
import org.apache.struts.validator.ValidatorForm;

import ${project.rootPackage}.web.fo.*;
import ${project.rootPackage}.data.to.*;

/**
 * The ActionForm used by ${f.cla(guiComponent.name)}Action.
 */
public class ${f.cla(guiComponent.name)}Form extends ValidatorForm {

	/**
	 * Log4J Logger for this class
	 */
	public static final Logger logger = Logger.getLogger(${f.cla(guiComponent.name)}Form.class);
<#-- Defined the macro that generates the bulk of the form -->
<#macro generateFormForGUIComponent(guiComp)>
	<#-- Setup some commonly used variables for the gui component -->
	<#if guiComp.identifyingRelationshipWithAncestor?exists>
		<#assign iRelationship = guiComp.identifyingRelationshipWithAncestor/>
		<#assign parentEntityName = f.cla(iRelationship.parentAssociationName)/>
		<#assign entityName = f.cla(iRelationship.childAssociationName)/>
	<#else>
		<#assign iRelationship = ""/>
		<#assign parentEntityName = ""/>
		<#assign entityName = f.cla(guiComp.entity.name)/>
	</#if>
	<#assign guiCompName = f.cla(guiComp.name)>
	<#assign guiCompNameA= f.att(guiComp.name)>

	// ----------- START ${guiCompName} -------------------- //
	<#switch guiComp.category>
		<#case GUIComponentStatics.CATEGORY_______LP>
			<#assign templateInclude = "/generic/includes/Form_______LP.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_EX_LC>
			<#assign templateInclude = "/generic/includes/Form_LP_EX_LC.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_DP_EX_LC>
			<#assign templateInclude = "/generic/includes/Form_DP_EX_LC.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_______DP>
			<#assign templateInclude = "/generic/includes/Form_______DP.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_EX_DP>
			<#assign templateInclude = "/generic/includes/Form_LP_EX_DP.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_EX_DC>
			<#assign templateInclude = "/generic/includes/Form_LP_EX_DC.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_DP_EX_DC>
			<#assign templateInclude = "/generic/includes/Form_DP_EX_DC.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_IN_LC>
			<#assign templateInclude = "/generic/includes/Form_LP_IN_LC.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_DP_IN_LC>
			<#assign templateInclude = "/generic/includes/Form_DP_IN_LC.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_IN_DP>
			<#assign templateInclude = "/generic/includes/Form_LP_IN_DP.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_IN_DC>
			<#assign templateInclude = "/generic/includes/Form_LP_IN_DC.java.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_DP_IN_DC>
			<#assign templateInclude = "/generic/includes/Form_DP_IN_DC.java.ftl"/>
			<#break>
	</#switch>

	// Include from '${templateInclude}'
	<#if templateInclude != "">
		<#include templateInclude/>
	<#else>
		UNKNOWN CATEGORY OF GUICOMPONENT
	</#if>

	// ----------- END ${guiCompName} -------------------- //

	<#list guiComp.internalChildren as child>
		<@generateFormForGUIComponent guiComp=child/>
	</#list>
</#macro>
<#-- Call the macro with the top level gui component -->
<@generateFormForGUIComponent guiComp=guiComponent/>

}
