<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=gui -->
<#-- version=1.0 -->
<#-- fileNameTemplate=${f.att(guiComponent.name)}.jsp -->
<#-- relativeOutputDirectory=web/WEB-INF/jsp -->
<#-- END TEMPLATE HEADER -->
<%--

  Copyright (c) 2004-2005 Code Canvas Technologies Pty Ltd. All Rights Reserved.

  Modification and redistribution of this file is permitted subject to the
  terms and conditions of the RapidJ End User License Agreement:
  http://www.codecanvas.com.au/rapidj/license.php

  {{$RapidJ$}}

--%>
<%--

${f.formatLines(project.copyright, '  ', 80)}

--%>
<%@ page errorPage="error.jsp" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-nested" prefix="nested" %>
<%@ taglib uri="/WEB-INF/tld/custom.tld" prefix="custom" %>
<#assign topLevelAncestor = guiComponent.topLevelAncestor/>
<#assign formName = f.att(topLevelAncestor.name) + "Form">
<#if guiComponent == topLevelAncestor>
<%-- Flag used to determine if a save button should be displayed --%>
<bean:define id="showSaveButton" toScope="request" value="false"/>

<html:html locale="true">
<head>
<title><bean:message key="application.title"/> - <bean:message key="${f.att(guiComponent.name)}.title"/></title>

<link rel="stylesheet" href="css/style.css" type="text/css">

<script language="JavaScript" type="text/javascript" src="CalendarPopup.js"></script>

<script language="JavaScript" type="text/javascript" src="common.js"></script>

<script language="JavaScript" type="text/javascript">

// <!-- Start

// End -->

</script>
</head>
<body>

<#if guiComponent.isDetail() || guiComponent.hasInternalDetailDescendant()>
<custom:javascript formName="${formName}"/>
</#if>

<nested:form action="/${f.att(guiComponent.name)}" method="POST">

<!-- Start outer table -->
<table class="outer" cellspacing="2">
	<tr>
		<td class="outerMenu" valign="top">
			<jsp:include page="menu.jsp"/>
		</td>
		<td class="outerMain" valign="top">

<!-- Start main table -->
<table class="main" cellspacing="0">

<#-- Errors -->
<%-- Errors for all properties including global --%>
<logic:messagesPresent>
<tr><td class="outerErrors">
<table class="errors" cellspacing="2">
	<tr>
		<td class="errors">
			<ul class="errors">
				<html:messages id="msg">
				<li class="errors">
					<nested:present name="msg"><bean:write name="msg"/></nested:present>
				</li>
				</html:messages>
			</ul>
		</td>
	</tr>
</table>
</td></tr>
</logic:messagesPresent>
<#-- Messages -->
<%-- Messages for all properties including global --%>
<logic:messagesPresent message="true">
<tr><td class="mainMessages">
<table class="messages" cellspacing="2">
	<tr>
		<td class="messages">
			<ul class="messages">
				<html:messages message="true" id="msg">
				<li class="messages">
					<nested:present name="msg"><bean:write name="msg"/></nested:present>
				</li>
				</html:messages>
			</ul>
		</td>
	</tr>
</table>
</td></tr>
</logic:messagesPresent>
<#-- Top Level GUIComponent -->
<tr><td class="mainGUIComponent">
	<@generateJSPForGUIComponent guiComp=guiComponent/>
</td></tr>
<#-- Buttons -->
<tr><td class="mainButtons">

<#-- Save Button -->
<%-- Save button --%>
<logic:equal name="showSaveButton" value="true" scope="request">
<input type="button" value="<bean:message key="common.save"/>" onclick="if (validate${f.cla(formName)}(document.${formName})) {doPost(document.${formName}, '${f.att(guiComponent.name)}.do', 'save', null, null, null);}">
</logic:equal>

<#-- Back Button -->
<%-- Back button --%>
<#if guiComponent.externalParent?exists>
	<#if guiComponent.externalParent.isList()>
<input type="button" value="<bean:message key="common.back"/>" onclick="doGet('${f.att(guiComponent.externalParent.topLevelAncestor.name)}.do', null, null, null, '${f.att(guiComponent.externalParent.name)}');">
	<#elseif guiComponent.externalParent.isDetail()>
		<#assign relationship = guiComponent.entity.getIdentifyingRelationshipWithParent(guiComponent.externalParent.entity)/>
<input type="button" value="<bean:message key="common.back"/>" onclick="doGet('${f.att(guiComponent.externalParent.topLevelAncestor.name)}.do', null, '${f.att(guiComponent.externalParent.name)}${guiComponent.externalParent.entity.name}Id', '<nested:write property="${f.att(guiComponent.name)}${f.cla(relationship.parentAssociationName)}Id"/>', '${f.att(guiComponent.externalParent.name)}');">
	</#if>
<#else>
<input type="button" value="<bean:message key="common.back"/>" onclick="doGet('./');">
</#if>

</td></tr>
<!-- End main table -->
</table>

</td></tr>
<!-- End outer table -->
</table>

</nested:form>

<%-- Time taken --%>
<span id="timeTaken"><bean:message key="common.timeTaken" arg0='<%=String.valueOf(System.currentTimeMillis()-((Long)request.getAttribute("start")).longValue())%>'/></span>

</body>
</html:html>
<#else><#-- (guiComponent != topLevelAncestor) -->
<nested:root name="${formName}">
	<@generateJSPForGUIComponent guiComp=guiComponent/>
</nested:root>
</#if>
<#------------------------------------------------------>
<#-- Macro to render gui components from the top down -->
<#macro generateJSPForGUIComponent(guiComp)>
	<#-- Setup some commonly used variables for the gui component -->
	<#if guiComp.identifyingRelationshipWithAncestor?exists>
		<#assign iRelationship = guiComp.identifyingRelationshipWithAncestor/>
		<#assign parentEntityName = f.cla(iRelationship.parentAssociationName)/>
		<#assign entityName = f.cla(iRelationship.childAssociationName)/>
	<#else>
		<#assign iRelationship = ""/>
		<#assign parentEntityName = ""/>
		<#assign entityName = f.cla(guiComp.entity.name)/>
	</#if>
	<#assign guiCompName = f.cla(guiComp.name)>
	<#assign guiCompNameA= f.att(guiComp.name)>

<table class="guiComponent" cellspacing="2">
<tr><td class="guiComponent">
<%-- START ${guiCompName} --%>

	<a name="${guiCompNameA}"></a>

	<#switch guiComp.category>
		<#case GUIComponentStatics.CATEGORY_______LP>
			<#assign includeFile = "/generic/includes/JSP_______LP.jsp.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_EX_LC>
			<#assign includeFile = "/generic/includes/JSP_LP_EX_LC.jsp.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_DP_EX_LC>
			<#assign includeFile = "/generic/includes/JSP_DP_EX_LC.jsp.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_______DP>
			<#assign includeFile = "/generic/includes/JSP_______DP.jsp.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_EX_DP>
			<#assign includeFile = "/generic/includes/JSP_LP_EX_DP.jsp.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_EX_DC>
			<#assign includeFile = "/generic/includes/JSP_LP_EX_DC.jsp.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_DP_EX_DC>
			<#assign includeFile = "/generic/includes/JSP_DP_EX_DC.jsp.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_IN_LC>
			<#assign includeFile = "/generic/includes/JSP_LP_IN_LC.jsp.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_DP_IN_LC>
			<#assign includeFile = "/generic/includes/JSP_DP_IN_LC.jsp.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_IN_DP>
			<#assign includeFile = "/generic/includes/JSP_LP_IN_DP.jsp.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_LP_IN_DC>
			<#assign includeFile = "/generic/includes/JSP_LP_IN_DC.jsp.ftl"/>
			<#break>
		<#case GUIComponentStatics.CATEGORY_DP_IN_DC>
			<#assign includeFile = "/generic/includes/JSP_DP_IN_DC.jsp.ftl"/>
			<#break>
	</#switch>

<%-- Include from '${includeFile}'--%>

	<#if includeFile != "">
		<#include includeFile/>
	<#else>
		UNKNOWN CATEGORY OF GUICOMPONENT
	</#if>

<%-- END ${guiCompName} --%>
</td></tr>
	<#-- Include the internal children JSPs -->
	<#list guiComp.internalChildren as child>
<tr><td class="guiComponent">
		<jsp:include page="${f.att(child.name)}.jsp"/>
</td></tr>
	</#list>

</table>

</#macro>
