<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=includes -->
<#-- version=1.0 -->
<#-- END TEMPLATE HEADER -->

	/**
	 * Adds a new ${entityName}.
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm
	 */
	public void execute${guiCompName}Add(Request request, ${formType} form) throws Exception {

		// Add a new empty FO to the form
		${guiCompName}${f.cla(guiComp.entity.name)}FO ${f.att(entityName)}FO = new ${guiCompName}${f.cla(guiComp.entity.name)}FO();
		${f.att(entityName)}FO.set${f.cla(guiComp.entity.name)}Id(new Long(-1));
		form.set${guiCompName}${entityName}FO(${f.att(entityName)}FO);
		form.set${guiCompName}${entityName}TO(null);

		// Populate the rest of the form
		populate${guiCompName}(request, form);
<#-- Clear its internal children components -->
<#list guiComp.internalChildren as child>

		// Clear the ${f.cla(child.name)}
		clear${f.cla(child.name)}(request, form);
</#list>

	}

	/**
	 * Edit the specified ${entityName}.
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	public void execute${guiCompName}Edit(Request request, ${formType} form) throws Exception {

<#-- Load the entity directly by id -->
		// Load the ${f.cla(guiComp.entity.name)}TO and use it to populate a FO.
		${f.cla(guiComp.entity.name)}TO ${f.att(entityName)}TO = DAOs.get${f.cla(guiComp.entity.name)}DAO().
			get${f.cla(guiComp.entity.name)}(form.get${guiCompName}${entityName}Id());
		form.set${guiCompName}${entityName}TO(${f.att(entityName)}TO);
		${guiCompName}${f.cla(guiComp.entity.name)}FO ${f.att(entityName)}FO = new ${guiCompName}${f.cla(guiComp.entity.name)}FO();
		copy(request, ${f.att(entityName)}FO, ${f.att(entityName)}TO);
		form.set${guiCompName}${entityName}FO(${f.att(entityName)}FO);
<#-- Set the parent id on the form -->
<#if guiComp.parent.parent?exists>

		// Set the parent ${parentEntityName} id on the form
		form.set${guiCompName}${parentEntityName}Id(
			${f.att(entityName)}TO.get${parentEntityName}Id());
</#if>

		// Populate the rest of the form
		populate${guiCompName}(request, form);
<#-- Populate internal child components -->
<#list guiComp.internalChildren as child>

		// Display the ${f.cla(child.name)}
	<#assign relationship = child.entity.getIdentifyingRelationshipWithParent(guiComp.entity)/>
		form.set${f.cla(child.name)}${f.cla(relationship.parentAssociationName)}Id(${f.att(entityName)}TO.get${f.cla(guiComp.entity.name)}Id());
	<#if child.isList()>
		execute${f.cla(child.name)}List(request, form);
	<#elseif child.isDetail()>
		execute${f.cla(child.name)}Edit(request, form);
	</#if>
</#list>

	}

	/**
	 * Save the ${entityName} being edited.
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	private void save${guiCompName}(Request request, ${formType} form) throws Exception {

<#-- Possibly a single instance of the entity to save-->
		if (form.get${guiCompName}${entityName}FO()!=null) {

			// Get the user populated FO
			${guiCompName}${f.cla(guiComp.entity.name)}FO ${f.att(entityName)}FO =
					form.get${guiCompName}${entityName}FO();
			${f.cla(guiComp.entity.name)}TO ${f.att(entityName)}TO = null;
			if ((${f.att(entityName)}FO.get${f.cla(guiComp.entity.name)}Id()==null) ||
					(${f.att(entityName)}FO.get${f.cla(guiComp.entity.name)}Id().longValue()<=0)) {
				// New record, create a new empty ${f.cla(guiComp.entity.name)}TO
				${f.att(entityName)}TO = new ${f.cla(guiComp.entity.name)}TO();
			} else {
				// Existing record, load the ${f.cla(guiComp.entity.name)}TO
				${f.att(entityName)}TO = DAOs.get${f.cla(guiComp.entity.name)}DAO().
						get${f.cla(guiComp.entity.name)}(${f.att(entityName)}FO.get${f.cla(guiComp.entity.name)}Id());
			}
			// Populate the ${f.cla(guiComp.entity.name)}TO with the FO
			copy(request, ${f.att(entityName)}TO, ${f.att(entityName)}FO);
<#-- Populate the TO instance with parents id -->
<#if guiComp.parent.parent?exists>
	<#-- Parent is list comp, so see if it had a parent, and use that -->
	<#-- (And the parents parent id should be a variable of the parent -->

			// Set the ${f.att(parentEntityName)}Id
			${f.att(entityName)}TO.set${parentEntityName}Id(
				form.get${guiCompName}${parentEntityName}Id());
</#if>

			// Save the ${entityName}
			Long id = DAOs.get${f.cla(guiComp.entity.name)}DAO().save${f.cla(guiComp.entity.name)}(
				${f.att(entityName)}TO, request.getRequest().getUserPrincipal());

			// Set the id on the form
			form.set${guiCompName}${entityName}Id(id);
<#-- And process each of its children also-->
<#list guiComp.internalChildren as child>

			// Setup and call save for the ${f.cla(child.name)}
	<#assign relationship = child.entity.getIdentifyingRelationshipWithParent(guiComp.entity)/>
			form.set${f.cla(child.name)}${f.cla(relationship.parentAssociationName)}Id(id);
			save${f.cla(child.name)}(request, form);
</#list>

		}

		// Clear the ${guiCompName} form variables
		clear${guiCompName}(request, form);

	}

	/**
	 * Populates the ${guiCompName} form variables.
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	private void populate${guiCompName}(Request request, ${formType} form) throws Exception {
<#-- Load a list of parent entities for those that have not been implied -->
<#list guiComp.entity.identifyingRelationshipsWithParents as relationship>
	<#if !guiComp.parent.parent?exists || relationship != iRelationship>

		// Load the list of available parent ${f.cla(relationship.parentAssociationName)}s
		form.set${guiCompName}${f.cla(relationship.parentAssociationName)}s(
		<#if relationship.isOneToOne() && relationship.isIdentifying()>
			DAOs.get${f.cla(relationship.parent.name)}DAO().get${f.cla(relationship.parent.name)}sWithNo${f.cla(relationship.childAssociationName)}(
				((form.get${guiCompName}${entityName}TO()==null) ?
					(null) : form.get${guiCompName}${entityName}TO().get${f.cla(relationship.parentAssociationName)}Id())));
		<#else>
			DAOs.get${f.cla(relationship.parent.name)}DAO().getAll${f.cla(relationship.parent.name)}s());
		</#if>
	</#if>
</#list>
<#-- Load the list of non identified children -->
<#list guiComp.entity.nonIdentifyingRelationshipsWithChildren as relationship>

		// Load the list of available ${f.cla(relationship.childAssociationName)}s
		form.set${guiCompName}${f.cla(relationship.childAssociationName)}s(
	<#-- Filtering by identifying parent does not make sense for non-identifying 1-1 relationships -->
	<#if relationship.child.getIdentifyingRelationshipWithParent(guiComp.entity)?exists &&
			relationship.child.getIdentifyingRelationshipWithParent(guiComp.entity).isOneToMany()>
			((form.get${guiCompName}${entityName}TO()==null)?(new ArrayList()):
				DAOs.get${f.cla(relationship.child.name)}DAO().
					get${f.cla(relationship.child.name)}sFor${relationship.child.getIdentifyingRelationshipWithParent(guiComp.entity).parentAssociationName}(
						form.get${guiCompName}${entityName}TO().get${f.cla(guiComp.entity.name)}Id())));
	<#else>
			DAOs.get${f.cla(relationship.child.name)}DAO().
					getAll${f.cla(relationship.child.name)}s());
	</#if>
</#list>

	}

	/**
	 * Clears the ${guiCompName} form variables and children components.
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	private void clear${guiCompName}(Request request, ${formType} form) throws Exception {

		// Clear the ${guiCompName} form variables
		// Note: dont clear parent IDs for top level components
		form.set${guiCompName}${entityName}TO(null);
		form.set${guiCompName}${entityName}FO(null);
<#list guiComp.entity.identifyingRelationshipsWithParents as relationship>
	<#if !guiComp.parent.parent?exists || relationship != iRelationship>
		form.set${guiCompName}${f.cla(relationship.parentAssociationName)}s(null);
	</#if>
</#list>
<#list guiComp.entity.nonIdentifyingRelationshipsWithChildren as relationship>
		form.set${guiCompName}${f.cla(relationship.childAssociationName)}s(null);
</#list>
<#-- Clear its internal children components -->
<#list guiComp.internalChildren as child>

		// Clear the nested ${f.cla(child.name)} form variables
		clear${f.cla(child.name)}(request, form);
</#list>

	}
