<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=includes -->
<#-- version=1.0 -->
<#-- END TEMPLATE HEADER -->

	/**
	 * Lists all ${entityName}s for the selected ${parentEntityName}
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	public void execute${guiCompName}List(Request request, ${formType} form) throws Exception {

<#-- List for the selected parent instance -->
		// Load the list of ${entityName}s for the ${parentEntityName}
		Long ${f.att(parentEntityName)}Id = form.get${guiCompName}${parentEntityName}Id();
		if (${f.att(parentEntityName)}Id==null) {
			throw new ActionException(
					ActionException.MISSING_REQUIRED_PARAMETER,
					"${guiCompNameA}${parentEntityName}Id", null);
		}
<#if guiComp.isPagingEnabled()>
		PagedData ${f.att(entityName)}TOs = DAOs.get${f.cla(guiComp.entity.name)}DAO().
			get${f.cla(guiComp.entity.name)}sFor${parentEntityName}(
				${f.att(parentEntityName)}Id,
				form.get${guiCompName}PageNumber(),
				ApplicationProperties.getInstance().getIntegerProperty(
					ApplicationProperties.${guiCompName?upper_case}_PAGESIZE, 10).intValue());
<#else>
		ArrayList ${f.att(entityName)}TOs = DAOs.get${f.cla(guiComp.entity.name)}DAO().
			get${f.cla(guiComp.entity.name)}sFor${parentEntityName}(${f.att(parentEntityName)}Id);
</#if>
		form.set${guiCompName}${entityName}TOs(${f.att(entityName)}TOs);
<#if guiComp.isPagingEnabled()>

		// Update the page number
		form.set${guiCompName}PageNumber(${f.att(entityName)}TOs.getPageNumber());
</#if>

		// Populate the rest of the form
		populate${guiCompName}(request, form);
<#-- Display the internal children components -->
<#list guiComp.internalChildren as child>

		// Display the ${f.cla(child.name)}
		<#if child_index==0>Long </#if>${f.att(guiComp.entity.name)}Id =
	<#if child.forSameEntity(guiComp)>
				form.get${f.cla(child.name)}${entityName}Id();
	<#else>
		<#assign relationship = child.entity.getIdentifyingRelationshipWithParent(guiComp.entity)/>
				form.get${f.cla(child.name)}${f.cla(relationship.parentAssociationName)}Id();
	</#if>
		if ((${f.att(guiComp.entity.name)}Id!=null) &&
				(DAOs.get${f.cla(guiComp.entity.name)}DAO().exists${f.cla(guiComp.entity.name)}For${f.cla(iRelationship.parentAssociationName)}(
					${f.att(guiComp.entity.name)}Id, ${f.att(parentEntityName)}Id))) {
	<#if child.isList()>
			execute${f.cla(child.name)}List(request, form);
	<#else>
			execute${f.cla(child.name)}Edit(request, form);
	</#if>
		} else {
			clear${f.cla(child.name)}(request, form);
		}
</#list>

	}

	/**
	 * Delete the specified ${guiCompName}
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	public void execute${guiCompName}Delete(Request request, ${formType} form) throws Exception {

		// Check that the id has been specified
		Long id = form.get${guiCompName}${entityName}Id();
		if (id==null) {
			throw new ActionException(
					ActionException.MISSING_REQUIRED_PARAMETER,
					"${guiCompNameA}${entityName}Id", null);
		}

		try {

			// Begin the transaction
			DatabaseUtils.begin();

			// Delete the specified ${guiCompName}
			DAOs.get${f.cla(guiComp.entity.name)}DAO().delete${f.cla(guiComp.entity.name)}(id);

			// Commit the transaction
			DatabaseUtils.commit();

		} catch (Exception e) {
			// Rollback the transaction and throw exception on.
			DatabaseUtils.rollback();
			throw e;
		}

		// Add a delete successfull message
		addGlobalMessage(request, "common.deleteOk");

		// Execute the top level method
		executeDefault(request, form);

	}

	/**
	 * Delegates to any children component saves
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	private void save${guiCompName}(Request request, ${formType} form) throws Exception {
<#list guiComp.internalChildren as child>

		// Delegate to the ${f.cla(child.name)} save
		save${f.cla(child.name)}(request, form);
</#list>

	}

	/**
	 * Populates the ${guiCompName} form variables.
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	private void populate${guiCompName}(Request request, ${formType} form) throws Exception {

<#-- Load and set the parent -->
		// Load the parent ${parentEntityName}
		form.set${guiCompName}${parentEntityName}TO(DAOs.get${f.cla(iRelationship.parent.name)}DAO().
				get${f.cla(iRelationship.parent.name)}(form.get${guiCompName}${parentEntityName}Id()));

	}

	/**
	 * Clears the ${guiCompName} form variables and children components.
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	private void clear${guiCompName}(Request request, ${formType} form) throws Exception {

		// Clear the ${guiCompName} form variables
		form.set${guiCompName}${entityName}TOs(null);
		form.set${guiCompName}${entityName}Id(null);
		form.set${guiCompName}${parentEntityName}Id(null);
		form.set${guiCompName}${parentEntityName}TO(null);
<#-- Clear its internal children components -->
<#list guiComp.internalChildren as child>

		// Clear the nested ${f.cla(child.name)} form variables
		clear${f.cla(child.name)}(request, form);
</#list>

	}
