<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=includes -->
<#-- version=1.0 -->
<#-- END TEMPLATE HEADER -->

	/**
	 * Adds a new ${guiCompName}.
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm
	 */
	public void execute${guiCompName}Add(Request request, ${formType} form) throws Exception {

		// Add a new empty FO to the form
		${guiCompName}${f.cla(guiComp.entity.name)}FO ${f.att(entityName)}FO = new ${guiCompName}${f.cla(guiComp.entity.name)}FO();
		${f.att(entityName)}FO.set${f.cla(guiComp.entity.name)}Id(IdentityUtils.
				getUniqueNegativeId(form.get${guiCompName}${entityName}FOs()));
		form.get${guiCompName}${f.cla(guiComp.entity.name)}FOs().add(${f.att(entityName)}FO);

		// Populate the rest of the form
		populate${guiCompName}(request, form);
<#-- Clear its internal children components -->
<#list guiComp.internalChildren as child>

		// Clear the ${f.cla(child.name)}
		clear${f.cla(child.name)}(request, form);
</#list>

	}

	/**
	 * Edit all of the ${f.cla(guiComp.entity.name)}s.
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	public void execute${guiCompName}Edit(Request request, ${formType} form) throws Exception {

		// Load the ${f.cla(guiComp.entity.name)}TOs and use them to populate FOs.
		ArrayList ${f.att(guiComp.entity.name)}TOs =
				DAOs.get${f.cla(guiComp.entity.name)}DAO().getAll${f.cla(guiComp.entity.name)}s();
		form.set${guiCompName}${f.cla(guiComp.entity.name)}TOs(${f.att(guiComp.entity.name)}TOs);
		form.get${guiCompName}${f.cla(guiComp.entity.name)}FOs().clear();
		for (Iterator iter = ${f.att(guiComp.entity.name)}TOs.iterator(); iter.hasNext(); ) {
			${f.cla(guiComp.entity.name)}TO ${f.att(guiComp.entity.name)}TO = (${f.cla(guiComp.entity.name)}TO) iter.next();
			${guiCompName}${f.cla(guiComp.entity.name)}FO ${f.att(guiComp.entity.name)}FO = new ${guiCompName}${f.cla(guiComp.entity.name)}FO();
			copy(request, ${f.att(guiComp.entity.name)}FO, ${f.att(guiComp.entity.name)}TO);
			form.get${guiCompName}${f.cla(guiComp.entity.name)}FOs().add(${f.att(guiComp.entity.name)}FO);
		}

		// Populate the rest of the form
		populate${guiCompName}(request, form);
<#-- Display the internal children components -->
<#list guiComp.internalChildren as child>

		// Display the ${f.cla(child.name)}
	<#assign relationship = child.entity.getIdentifyingRelationshipWithParent(guiComp.entity)/>
		<#if child_index==0>Long </#if>${f.att(guiComp.entity.name)}Id = form.get${f.cla(child.name)}${f.cla(relationship.parentAssociationName)}Id();
		if ((${f.att(guiComp.entity.name)}Id!=null) &&
				(DAOs.get${f.cla(guiComp.entity.name)}DAO().
					exists${f.cla(guiComp.entity.name)}(${f.att(guiComp.entity.name)}Id))) {
	<#if child.isList()>
			execute${f.cla(child.name)}List(request, form);
	<#else>
			execute${f.cla(child.name)}Edit(request, form);
	</#if>
		} else {
			clear${f.cla(child.name)}(request, form);
		}
</#list>

	}

	/**
	 * Delete the specified ${guiCompName}
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	public void execute${guiCompName}Delete(Request request, ${formType} form) throws Exception {

		// Check that the id has been specified
		Long id = form.get${guiCompName}${entityName}Id();
		if (id==null) {
			throw new ActionException(
					ActionException.MISSING_REQUIRED_PARAMETER,
					"${guiCompNameA}${entityName}Id", null);
		}

		if (id.longValue() <= 0) {
			// Has not been saved yet, just remove from list.
			IdentityUtils.removeIdentifiable(id, form.get${guiCompName}${entityName}FOs());
		} else {

			try {

				// Begin the transaction
				DatabaseUtils.begin();

				// Remove it using the DAO
				DAOs.get${f.cla(guiComp.entity.name)}DAO().delete${f.cla(guiComp.entity.name)}(id);

				// Commit the transaction
				DatabaseUtils.commit();

			} catch (Exception e) {
				// Rollback the transaction and throw exception on.
				DatabaseUtils.rollback();
				throw e;
			}

			// Execute the top level method to refresh the page
			executeDefault(request, form);
		}

		// Add a delete successfull message
		addGlobalMessage(request, "common.deleteOk");

	}

	/**
	 * Save the ${f.cla(guiComp.entity.name)}s being edited.
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	private void save${guiCompName}(Request request, ${formType} form) throws Exception {

<#-- Possibly many instances of the entity to save-->
		if (form.get${guiCompName}${f.cla(guiComp.entity.name)}FOs()!=null) {
			// Get the user populated FOs
			for (Iterator iter = form.get${guiCompName}${entityName}FOs().iterator(); iter.hasNext(); ) {
				${guiCompName}${f.cla(guiComp.entity.name)}FO ${f.att(entityName)}FO = (${guiCompName}${f.cla(guiComp.entity.name)}FO) iter.next();
				${f.cla(guiComp.entity.name)}TO ${f.att(entityName)}TO = null;
				if ((${f.att(entityName)}FO.get${f.cla(guiComp.entity.name)}Id()==null) ||
						(${f.att(entityName)}FO.get${f.cla(guiComp.entity.name)}Id().longValue()<=0)) {
					// New record, create a new empty ${f.cla(guiComp.entity.name)}TO
					${f.att(entityName)}TO = new ${f.cla(guiComp.entity.name)}TO();
				} else {
					// Existing record, load the ${f.cla(guiComp.entity.name)}TO
					${f.att(entityName)}TO = DAOs.get${f.cla(guiComp.entity.name)}DAO().
						get${f.cla(guiComp.entity.name)}(${f.att(entityName)}FO.get${f.cla(guiComp.entity.name)}Id());
				}
				// Populate the ${f.cla(guiComp.entity.name)}TO with the FO
				copy(request, ${f.att(entityName)}TO, ${f.att(entityName)}FO);

				// Save the ${f.cla(guiComp.entity.name)}
				DAOs.get${f.cla(guiComp.entity.name)}DAO().save${f.cla(guiComp.entity.name)}(
					${f.att(entityName)}TO, request.getRequest().getUserPrincipal());

			}
<#-- And process each of its children also-->
<#list guiComp.internalChildren as child>

			// Call save for the child ${f.cla(child.name)}
	<#assign relationship = child.entity.getIdentifyingRelationshipWithParent(guiComp.entity)/>
			save${f.cla(child.name)}(request, form);
</#list>

			// Clear the ${guiCompName} form variables
			clear${guiCompName}(request, form);

		}
	}

	/**
	 * Populates the ${guiCompName} form variables.
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	private void populate${guiCompName}(Request request, ${formType} form) throws Exception {
<#-- Load a list of parent entities for those that have not been implied -->
<#list guiComp.entity.identifyingRelationshipsWithParents as relationship>
	<#if relationship.isOneToMany()>
		// Load the list of available parent ${f.cla(relationship.parentAssociationName)}s
		form.set${guiCompName}${f.cla(relationship.parentAssociationName)}s(
			DAOs.get${f.cla(relationship.parent.name)}DAO().getAll${f.cla(relationship.parent.name)}s());
	</#if>
</#list>
<#-- Load the list of non identified children -->
<#list guiComp.entity.nonIdentifyingRelationshipsWithChildren as relationship>
		// Load the list of available ${f.cla(relationship.childAssociationName)}s
		form.set${guiCompName}${f.cla(relationship.childAssociationName)}s(
			DAOs.get${f.cla(relationship.child.name)}DAO().
				getAll${f.cla(relationship.child.name)}s());
</#list>

	}

	/**
	 * Clears the ${guiCompName} form variables and children components.
	 *
	 * @param request - the current Request.
	 * @param form - the ActionForm.
	 */
	private void clear${guiCompName}(Request request, ${formType} form) throws Exception {

		// Clear the ${guiCompName} form variables
		form.set${guiCompName}${f.cla(guiComp.entity.name)}Id(null);
		form.set${guiCompName}${f.cla(guiComp.entity.name)}TOs(null);
		form.get${guiCompName}${f.cla(guiComp.entity.name)}FOs().clear();
<#list guiComp.entity.identifyingRelationshipsWithParents as relationship>
	<#if relationship.isOneToMany()>
		form.set${guiCompName}${f.cla(relationship.parentAssociationName)}s(null);
	</#if>
</#list>
<#list guiComp.entity.nonIdentifyingRelationshipsWithChildren as relationship>
		form.set${guiCompName}${f.cla(relationship.childAssociationName)}s(null);
</#list>
<#-- Clear its internal children components -->
<#list guiComp.internalChildren as child>

		// Clear the nested ${f.cla(child.name)} form variables
		clear${f.cla(child.name)}(request, form);
</#list>

	}
