<#-- START TEMPLATE HEADER -->
<#-- category=generic -->
<#-- type=includes -->
<#-- version=1.0 -->
<#-- END TEMPLATE HEADER -->
<div class="detailHeader"><bean:message key="${guiCompNameA}.header"/>
<#-- Display the details for the selected entity from the parent gui component -->
<nested:present property="${guiCompNameA}${parentEntityName}TO">
	- <bean:message key="${guiCompNameA}.${f.att(iRelationship.parentAssociationName)}.displayName"/>
	<nested:write property="${guiCompNameA}${parentEntityName}TO.<#if iRelationship.parent.userIdentifier?exists>${f.att(iRelationship.parent.userIdentifier.name)}<#else>${f.att(iRelationship.parent.name)}Id</#if>"/>
</nested:present>
</div>

<#-- Show the details (as list or single instance) -->
<#if iRelationship.isOneToMany()>
<nested:present property="${guiCompNameA}${entityName}FOs">
<nested:iterate property="${guiCompNameA}${entityName}FOs" indexId="index">
	<%-- If the FO exists then put the TO in the page context (clear it first) --%>
	<% pageContext.removeAttribute("${f.att(entityName)}TO"); %>
	<nested:greaterThan property="${f.att(guiComp.entity.name)}Id" value="0">
		<nested:define id="${f.att(entityName)}TO" property='<%=("../${guiCompNameA}${entityName}TOs["+index+"]")%>' toScope="page"/>
	</nested:greaterThan>
<#else>
<nested:present property="${guiCompNameA}${entityName}FO">
<nested:nest property="${guiCompNameA}${entityName}FO">
	<nested:greaterThan property="${f.att(guiComp.entity.name)}Id" value="0">
		<nested:define id="${f.att(entityName)}TO" property="../${guiCompNameA}${entityName}TO" toScope="page"/>
	</nested:greaterThan>
</#if>

<% request.setAttribute("showSaveButton", "true"); %>

<table class="detail" cellspacing="0">
<#-- Include the detail form -->
<#include "JSP_DetailForm.jsp.ftl"/>
<#-- Allow user to select a parent entity, if it has not been implied -->
<#list guiComp.entity.identifyingRelationshipsWithParents as relationship>
	<#if relationship != iRelationship>
	<tr>
		<td class="fieldName"><bean:message key="${guiCompNameA}.${f.att(relationship.parentAssociationName)}.displayName"/> *</td>
		<td class="fieldValue">
			<nested:select property="${f.att(relationship.parentAssociationName)}Id">
				<nested:optionsCollection property="/${guiCompNameA}${f.cla(relationship.parentAssociationName)}s" label="<#if relationship.parent.userIdentifier?exists>${f.att(relationship.parent.userIdentifier.name)}<#else>${f.att(relationship.parent.name)}Id</#if>" value="${f.att(relationship.parent.name)}Id"/>
			</nested:select>
		</td>
	</tr>
	</#if>
</#list>
<#-- Allow user to select non identified children -->
<#list guiComp.entity.nonIdentifyingRelationshipsWithChildren as relationship>
	<tr>
		<td class="fieldName"><bean:message key="${guiCompNameA}.${f.att(relationship.childAssociationName)}.displayName"/></td>
		<td class="fieldValue">
			<nested:select property="${f.att(relationship.childAssociationName)}Id">
				<option value=""><bean:message key="common.none"/></option>
				<nested:optionsCollection property="/${guiCompNameA}${f.cla(relationship.childAssociationName)}s" label="<#if relationship.child.userIdentifier?exists>${f.att(relationship.child.userIdentifier.name)}<#else>${f.att(relationship.child.name)}Id</#if>" value="${f.att(relationship.child.name)}Id"/>
			</nested:select>
		</td>
	</tr>
</#list>
	<tr>
		<td class="detailLinks" colspan="2">
			<%-- Display children links if existing --%>
			<nested:greaterThan property="${f.att(guiComp.entity.name)}Id" value="0">
<#-- Internal children links -->
<#if iRelationship.isOneToMany()>
	<#list guiComp.internalChildren as childGUIComp>
		<#assign relationship = childGUIComp.entity.getIdentifyingRelationshipWithParent(guiComp.entity)/>
		<#if childGUIComp.isDetail()>
			<a href="${f.att(topLevelAncestor.name)}.do?dispatch=${f.att(childGUIComp.name)}Edit&${f.att(childGUIComp.name)}${f.cla(relationship.parentAssociationName)}Id=<nested:write property="${f.att(guiComp.entity.name)}Id"/>#${f.att(childGUIComp.name)}"><bean:message key="${guiCompNameA}.${f.att(childGUIComp.name)}.${f.att(relationship.childAssociationName)}.displayName"/></a>
		<#else>
			<a href="${f.att(topLevelAncestor.name)}.do?dispatch=${f.att(childGUIComp.name)}List&${f.att(childGUIComp.name)}${f.cla(relationship.parentAssociationName)}Id=<nested:write property="${f.att(guiComp.entity.name)}Id"/>#${f.att(childGUIComp.name)}"><bean:message key="${guiCompNameA}.${f.att(childGUIComp.name)}.${f.att(relationship.childAssociationName)}.displayName"/></a>
		</#if>
	</#list>
</#if>
<#-- External children links -->
<#list guiComp.externalChildren as childGUIComp>
	<#assign relationship = childGUIComp.entity.getIdentifyingRelationshipWithParent(guiComp.entity)/>
	<#if childGUIComp.isDetail()>
			<a href="${f.att(childGUIComp.name)}.do?dispatch=${f.att(childGUIComp.name)}Edit&${f.att(childGUIComp.name)}${f.cla(relationship.parentAssociationName)}Id=<nested:write property="${f.att(guiComp.entity.name)}Id"/>"><bean:message key="${guiCompNameA}.${f.att(childGUIComp.name)}.${f.att(relationship.childAssociationName)}.displayName"/></a>
	<#else>
			<a href="${f.att(childGUIComp.name)}.do?dispatch=${f.att(childGUIComp.name)}List&${f.att(childGUIComp.name)}${f.cla(relationship.parentAssociationName)}Id=<nested:write property="${f.att(guiComp.entity.name)}Id"/>"><bean:message key="${guiCompNameA}.${f.att(childGUIComp.name)}.${f.att(relationship.childAssociationName)}.displayName"/></a>
	</#if>
</#list>
			</nested:greaterThan>
<#-- Delete link -->
			<a href="${f.att(topLevelAncestor.name)}.do?dispatch=${guiCompNameA}Delete&${guiCompNameA}${entityName}Id=<nested:write property="${f.att(guiComp.entity.name)}Id"/>#${guiCompNameA}" onclick="return confirm('<bean:message key="common.confirmDelete"/>');"><bean:message key="common.delete"/></a>
		</td>
	</tr>
</table>
<#if iRelationship.isOneToMany()>
</nested:iterate>
</nested:present>
<#else>
</nested:nest>
</nested:present>
</#if>

<%-- Only display the Add button if the parent is present --%>
<nested:present property="${guiCompNameA}${parentEntityName}Id">
<#if iRelationship.isOneToMany()>
	<#-- "Add New" button for 1-M -->
	<input type="button" value="<bean:message key="common.add"/>" onclick="doPost(document.${formName}, '${f.att(guiComp.topLevelAncestor.name)}.do', '${guiCompNameA}Add', null, null, '${guiCompNameA}');">
<#else>
	<#-- "Add New" button for 1-1 -->
	<nested:notPresent property="${guiCompNameA}${entityName}FO">
		<input type="button" value="<bean:message key="common.add"/>" onclick="doPost(document.${formName}, '${f.att(guiComp.topLevelAncestor.name)}.do', '${guiCompNameA}Add', null, null, '${guiCompNameA}');">
	</nested:notPresent>
</#if>
</nested:present>
